﻿
using JetBrains.Annotations;
using OpcLabs.BaseLib.DataTypeModel;

namespace OpcLabs.BaseLibFactory.DataTypeModel
{
    static public class DataFieldInstances
    {
        [NotNull]
        static public DataField IncompleteInstance1 => new DataField("aFieldName", null);

        [NotNull]
        static public DataField IncompleteInstance2 => new DataField("aFieldName2", SequenceDataTypeInstances.IncompleteInstance2);

        [NotNull]
        static public DataField Instance1 => new DataField("aFieldName", PrimitiveDataTypeInstances.Instance1);

        [NotNull] static public DataField Instance2 =>
            new DataField("aFieldName2", OpaqueDataTypeInstances.Instance2) {IsLength = true};

        [NotNull]
        static public DataField Instance3 =>
            new DataField("aFieldName3", SequenceDataTypeInstances.Instance5) { IsOptional = true};

        [NotNull]
        static public DataField Instance4 =>
            new DataField("aFieldName4", OpaqueDataTypeInstances.Instance4) { IsSwitch = true };

        [NotNull] static public DataField Instance5 =>
            new DataField("aFieldName5", PrimitiveDataTypeInstances.Instance4)
            {
                Description = "aDescription",
                IsLength = true,
                IsOptional = true,
                IsSwitch = true
            };
    }
}
