﻿
using JetBrains.Annotations;
using OpcLabs.BaseLib.DataTypeModel;

namespace OpcLabs.BaseLibFactory.DataTypeModel
{
    static public class SequenceDataTypeInstances
    {
        [NotNull]
        static public SequenceDataType IncompleteInstance1 => new SequenceDataType(-1, null);

        [NotNull]
        static public SequenceDataType IncompleteInstance2 => new SequenceDataType(-1, StructuredDataTypeInstances.IncompleteInstance1);

        [NotNull]
        static public SequenceDataType Instance0 => new SequenceDataType();

        [NotNull]
        static public SequenceDataType Instance1 => new SequenceDataType(OpaqueDataTypeInstances.Instance1);

        [NotNull]
        static public SequenceDataType Instance2 => new SequenceDataType(20000, OpaqueDataTypeInstances.Instance1);

        [NotNull] static public SequenceDataType Instance3 =>
            new SequenceDataType("aName", OpaqueDataTypeInstances.Instance2, 30000);

        [NotNull]
        static public SequenceDataType Instance4 =>
            new SequenceDataType("aName2", "aFullName2", OpaqueDataTypeInstances.Instance3, 40000);

        [NotNull]
        static public SequenceDataType Instance5 =>
            new SequenceDataType("aName3", "aFullName3", OpaqueDataTypeInstances.Instance4, 50000) {Description = "aDescription"};
    }
}
