﻿using System.Runtime.InteropServices;
using JetBrains.Annotations;
using OpcLabs.BaseLib.Data;
using OpcLabs.BaseLibFactory;
using OpcLabs.EasyOpc.DataAccess.Connectivity;

namespace OpcLabs.EasyOpcFactory.DataAccess.Connectivity
{
    static public class DAItemPointReadArgumentsInstances
    {
        [NotNull]
        static public DAItemPointReadArguments Instance0 => new DAItemPointReadArguments();

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1065:DoNotRaiseExceptionsInUnexpectedLocations")]
        [NotNull]
        static public DAItemPointReadArguments Instance1
        {
            get
            {
                var itemPointReadArguments = new DAItemPointReadArguments 
                {
                    ErrorCode = -111,
                    Exception = new COMException("comException1", 112),
                    ErrorMessage = "errorMessage1",
                    Quality = DAQualityInstances.Instance1,
                    StatusInfo = StatusInfo.Normal,
                    Timestamp = DateTimeUtcInstances.Kind_Utc,
                    TimestampLocal = DateTimeLocalInstances.Kind_Local,
                    Value = 2222.2f,
                    Vtq = DAVtqInstances.ADouble,
                };
                return itemPointReadArguments;
            }
        }
    }
}
