﻿using System;
using JetBrains.Annotations;
using OpcLabs.BaseLibFactory;
using OpcLabs.EasyOpc.UA.OperationModel;

namespace OpcLabs.EasyOpcFactory.UA.OperationModel
{
    static public class UACallArgumentsInstances
    {
        [NotNull]
        static public UACallArguments Instance0 => new UACallArguments();

        [NotNull]
        static public UACallArguments Instance1 => new UACallArguments(UANodeArgumentsInstances.Instance1);

        [NotNull]
        static public UACallArguments Instance2 => new UACallArguments(UANodeArgumentsInstances.Instance1) { MethodNodeDescriptor = UANodeDescriptorInstances.Instance2, InputArguments = ObjectArrayInstances.MoreElements };

        [NotNull]
        static public UACallArguments Instance3
        {
            get
            {
                UACallArguments callArguments = Instance2;
                callArguments.InputTypes = new [] { typeof(bool), typeof(SByte), typeof(Byte), typeof(short), typeof(ushort), typeof(int), typeof(uint), typeof(long), typeof(ulong), typeof(float), typeof(double) };
                return callArguments;
            }
        }
    }
}
