﻿using System;
using System.IO;
using System.Runtime.InteropServices;
using JetBrains.Annotations;
using OpcLabs.EasyOpc.UA.OperationModel;

namespace OpcLabs.EasyOpcFactory.UA.OperationModel
{
    static public class EasyUAEventNotificationEventArgsInstances
    {
        [NotNull]
        static public EasyUAEventNotificationEventArgs Instance0 => new EasyUAEventNotificationEventArgs();

        [NotNull]
        static public EasyUAEventNotificationEventArgs Instance1 => new EasyUAEventNotificationEventArgs
        {
            ErrorCode = -1,
            ErrorMessage = "TestMessage1"
        };

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1065:DoNotRaiseExceptionsInUnexpectedLocations")]
        [NotNull]
        static public EasyUAEventNotificationEventArgs Instance2 => new EasyUAEventNotificationEventArgs
        {
            ErrorCode = -2,
            Exception = new COMException("TestMessage2"),
            Diagnostics = { new ApplicationException("Diagnostics1", new IOException("Diagnostics2")) }
        };

        [NotNull]
        static public EasyUAEventNotificationEventArgs Instance3 => new EasyUAEventNotificationEventArgs
        {
            Arguments = EasyUAMonitoredItemArgumentsInstances.Instance1
        };

        [NotNull]
        static public EasyUAEventNotificationEventArgs Instance4 => new EasyUAEventNotificationEventArgs
        {
            Arguments = EasyUAMonitoredItemArgumentsInstances.Instance1,
            EventData = UAEventDataInstances.Instance1
        };

        [NotNull]
        static public EasyUAEventNotificationEventArgs Instance5 => new EasyUAEventNotificationEventArgs
        {
            Arguments = EasyUAMonitoredItemArgumentsInstances.Instance2,
            EventData = UAEventDataInstances.Instance1,
            Refresh = true,
        };

        [NotNull]
        static public EasyUAEventNotificationEventArgs Instance6 => new EasyUAEventNotificationEventArgs
        {
            Arguments = EasyUAMonitoredItemArgumentsInstances.Instance3,
            EventData = UAEventDataInstances.Instance1,
            RefreshComplete = true,
        };

        [NotNull]
        static public EasyUAEventNotificationEventArgs Instance7 => new EasyUAEventNotificationEventArgs
        {
            Arguments = EasyUAMonitoredItemArgumentsInstances.Instance3,
            EventData = UAEventDataInstances.Instance1,
            RefreshInitiated = true,
        };
    }
}
