﻿using JetBrains.Annotations;
using OpcLabs.BaseLib.Collections.Generic.Extensions;
using OpcLabs.BaseLib.OperationModel;
using OpcLabs.BaseLibFactory;
using OpcLabs.BaseLibFactory.OperationModel;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.AlarmsAndConditions;
using OpcLabs.EasyOpc.UA.Filtering;
using OpcLabs.EasyOpcFactory.UA.AddressSpace;
using OpcLabs.EasyOpcFactory.UA.Filtering;

namespace OpcLabs.EasyOpcFactory.UA
{
    static public class UAFieldResultDictionaryInstances
    {
        [NotNull]
        static public UAFieldResultDictionary Instance1
        {
            get
            {
                var attributeValues = new UAFieldResultDictionary();
                attributeValues.AddNew(UASimpleAttributeOperand.Null, ValueResultInstances.Instance0);
                attributeValues.AddNew(UASimpleAttributeOperandInstances.Instance1, ValueResultInstances.Instance2);
                attributeValues.AddNew(UASimpleAttributeOperandInstances.Instance2, ValueResultInstances.Instance2);
                return attributeValues;
            }
        }

        [NotNull]
        static public UAFieldResultDictionary Instance2_BaseEvent
        {
            get
            {
                var attributeValues = new UAFieldResultDictionary();
                attributeValues.AddNew(UABaseEventObject.Operands.NodeId, new ValueResult(state: null, value: UANodeIdInstances.StringIdentifier_Normal));
                return attributeValues;
            }
        }

        [NotNull]
        static public UAFieldResultDictionary Instance3_BaseEvent
        {
            get
            {
                var attributeValues = new UAFieldResultDictionary();
                attributeValues.AddNew(UABaseEventObject.Operands.EventId, new ValueResult(state: null, value: new byte[] { 111, 222, 0, 255 }));
                attributeValues.AddNew(UABaseEventObject.Operands.EventType, new ValueResult(state: null, value: UANodeIdInstances.NumericIdentifier_Positive));
                attributeValues.AddNew(UABaseEventObject.Operands.LocalTime, new ValueResult(state: null, value: UATimeZoneDataInstances.Instance1));
                attributeValues.AddNew(UABaseEventObject.Operands.Message, new ValueResult(state: null, value: "testMessage"));
                attributeValues.AddNew(UABaseEventObject.Operands.NodeId, new ValueResult(state: null, value: UANodeIdInstances.OpaqueIdentifier_Length5));
                attributeValues.AddNew(UABaseEventObject.Operands.ReceiveTime, new ValueResult(state: null, value: DateTimeUtcInstances.Kind_Utc));
                attributeValues.AddNew(UABaseEventObject.Operands.Severity, new ValueResult(state: null, value: 1111111111));
                attributeValues.AddNew(UABaseEventObject.Operands.SourceName, new ValueResult(state: null, value: "testSourceName"));
                attributeValues.AddNew(UABaseEventObject.Operands.SourceNode, new ValueResult(state: null, value: UANodeIdInstances.GuidIdentifier_Normal));
                attributeValues.AddNew(UABaseEventObject.Operands.Time, new ValueResult(state: null, value: DateTimeBoundaryInstances.MinValue));
                return attributeValues;
            }
        }

        [NotNull]
        static public UAFieldResultDictionary Instance4_BaseEvent
        {
            get
            {
                var attributeValues = new UAFieldResultDictionary();
                attributeValues.AddNew(UABaseEventObject.Operands.ReceiveTime, new ValueResult(state: null, value: DateTimeUtcInstances.Kind_Utc));
                attributeValues.AddNew(UABaseEventObject.Operands.Severity, new ValueResult(state: null, value: 1111111111));
                attributeValues.AddNew(UABaseEventObject.Operands.SourceName, new ValueResult(state: null, value: "testSourceName"));
                attributeValues.AddNew(UABaseEventObject.Operands.SourceNode, new ValueResult(state: null, value: UANodeIdInstances.GuidIdentifier_Normal));
                attributeValues.AddNew(UABaseEventObject.Operands.Time, new ValueResult(state: null, value: DateTimeBoundaryInstances.MinValue));
                return attributeValues;
            }
        }

        [NotNull]
        static public UAFieldResultDictionary Instance5_BaseEvent
        {
            get
            {
                var attributeValues = new UAFieldResultDictionary();
                attributeValues.AddNew(UABaseEventObject.Operands.EventId, new ValueResult(state: null, value: new byte[] { 111, 222, 0, 255 }));
                attributeValues.AddNew(UABaseEventObject.Operands.EventType, new ValueResult(state: null, value: UANodeIdInstances.NumericIdentifier_Positive));
                attributeValues.AddNew(UABaseEventObject.Operands.LocalTime, new ValueResult(state: null, value: UATimeZoneDataInstances.Instance1));
                attributeValues.AddNew(UABaseEventObject.Operands.Message, new ValueResult(state: null, value: "testMessage"));
                attributeValues.AddNew(UABaseEventObject.Operands.NodeId, new ValueResult(state: null, value: UANodeIdInstances.OpaqueIdentifier_Length5));
                return attributeValues;
            }
        }

        [NotNull]
        static public UAFieldResultDictionary Instance6_BaseEvent
        {
            get
            {
                var attributeValues = new UAFieldResultDictionary();
                attributeValues.AddNew(UABaseEventObject.Operands.SourceName, new ValueResult(state: null, value: "testSourceName"));
                attributeValues.AddNew(UABaseEventObject.Operands.SourceNode, new ValueResult(state: null, value: UANodeIdInstances.GuidIdentifier_Normal));
                attributeValues.AddNew(UABaseEventObject.Operands.Time, new ValueResult(state: null, value: DateTimeBoundaryInstances.MinValue));
                return attributeValues;
            }
        }

        [NotNull]
        static public UAFieldResultDictionary Instance7_BaseEvent
        {
            get
            {
                var attributeValues = new UAFieldResultDictionary();
                attributeValues.AddNew(UABaseEventObject.Operands.ReceiveTime, new ValueResult(state: null, value: DateTimeUtcInstances.Kind_Utc));
                attributeValues.AddNew(UABaseEventObject.Operands.Severity, new ValueResult(state: null, value: 1111111111));
                return attributeValues;
            }
        }

        [NotNull]
        static public UAFieldResultDictionary Instance8_BaseEvent
        {
            get
            {
                var attributeValues = new UAFieldResultDictionary();
                attributeValues.AddNew(UABaseEventObject.Operands.Severity, new ValueResult(state: null, value: 1111111111));
                return attributeValues;
            }
        }

        [NotNull]
        static public UAFieldResultDictionary Instance9_BaseEvent
        {
            get
            {
                var attributeValues = new UAFieldResultDictionary();
                attributeValues.AddNew(UABaseEventObject.Operands.ReceiveTime, new ValueResult(state: null, value: DateTimeUtcInstances.Kind_Utc));
                return attributeValues;
            }
        }
    }
}
