﻿using System;
using System.Xml;
using JetBrains.Annotations;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpcFactory.UA.AddressSpace;

namespace OpcLabs.EasyOpcFactory.UA
{
    static public class UAExtensionObjectInstances
    {
        [NotNull]
        static public UAExtensionObject NoneInstance1 => new UAExtensionObject(UANodeIdInstances.StringIdentifier_Normal);

        [NotNull]
        static public UAExtensionObject ByteInstance0 => new UAExtensionObject(new Byte[0]);

        [NotNull]
        static public UAExtensionObject ByteInstance1 => new UAExtensionObject(new Byte[] {11, 22, 33, 44, 55});

        [NotNull]
        static public UAExtensionObject ByteInstance2 => new UAExtensionObject(
            UANodeIdInstances.NumericIdentifier_Positive,
            new Byte[] { 11, 22, 33, 44, 55 });

        [NotNull]
        static public UAExtensionObject XmlInstance1 => new UAExtensionObject(new XmlDocument().CreateElement("TestName"));


        [NotNull]
        static public UAExtensionObject XmlInstance2 => new UAExtensionObject(
            UANodeIdInstances.OpaqueIdentifier_Length5,
            new XmlDocument().CreateElement("TestName"));
    }
}
