﻿
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc;
using OpcLabs.EasyOpc.AlarmsAndEvents;
using OpcLabs.EasyOpc.AlarmsAndEvents.AddressSpace;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.AlarmsAndEvents
{
    partial class EasyAEClientTest
    {
        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BrowseNodesTest_Basic_Root()
        {
            BrowseNodesTest_Basic(TestEnvironment.OpcLabs_KitEventServer.ServerDescriptors.WithProgId, AENodeDescriptor.Root, 1);
        }


        private void BrowseNodesTest_Basic(
            [NotNull] ServerDescriptor serverDescriptor,
            [NotNull] AENodeDescriptor parentNodeDescriptor,
            int expectedCount)  // -1 for "unknown"
        {
            TestSection.Arrange();
            TestEnvironment.PrecheckServer(serverDescriptor);
            var client = new EasyAEClient();

            TestSection.Act();
            AENodeElementCollection nodeElements = client.BrowseNodes(
                serverDescriptor,
                parentNodeDescriptor,
                AEBrowseParameters.Empty);

            TestSection.Assert();
            Assert.IsNotNull(nodeElements);
            AssertUtilities.WriteLine(nodeElements.Count);
            CollectionAssert.AllItemsAreNotNull(nodeElements);
            foreach (AENodeElement nodeElement in nodeElements)
                AssertUtilities.WriteLine(nodeElement);
            if (expectedCount >= 0)
                Assert.AreEqual(expectedCount, nodeElements.Count);
        }
    }
}
