﻿

using System;
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.OperationModel;
using OpcLabs.EasyOpcLiveTest.DataAccess.Environment;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.DataAccess
{
    partial class EasyDAClientTest_Com
    {
        //#if (NETFRAMEWORK)
        //        [DynamicData(nameof(OpcLabs_KitServer.ReadableItemCatalogEntryDataRows), typeof(OpcLabs_KitServer))]
        //        [TestCategory("Live")]
        //        [TestCategory("OpcClassic")]
        //        [TestCategory("OpcDataAccess")]
        //        [TestMethod]
        //        public void ReadItemCatalogTest_Com_Basic([NotNull] DAItemCatalogEntry itemCatalogEntry)
        //        {
        //            ReadItemCatalogTest_Basic(TestEnvironment.OpcLabs_KitServer.ServerDescriptors.WithProgId, itemCatalogEntry);
        //        }
        //#endif

#if !(NETFRAMEWORK)
        [DynamicData(nameof(TestEnvironment.OpcLabs_KitServer_OptimisticSupportedServerDescriptorDataRows), typeof(TestEnvironment))]
        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void ReadItemTest_Com_NotSupported([NotNull] ServerDescriptor serverDescriptor)
        {
            TestSection.Arrange();
            AssertUtilities.WriteLine(serverDescriptor);
            var client = new EasyDAClient();
            DAItemDescriptor itemDescriptor = "Static/Analog Types/Int";

            TestSection.Act();
            try
            {
                try
                {
                    client.ReadItem(serverDescriptor, itemDescriptor);
                }
                finally
                {
                    TestSection.Assert();
                }
            }
            catch (Exception exception)
            {
                AssertUtilities.WriteLine(exception.GetType());
                AssertUtilities.WriteLine(exception.Message ?? String.Empty);
                Assert.IsInstanceOfType(exception, typeof(OpcException));
                var opcException = (OpcException) exception;
                Exception innerException = opcException.InnerException;
                Assert.IsNotNull(innerException);
                AssertUtilities.WriteLine(innerException.GetType());
                string innerExceptionMessage = innerException.Message;
                AssertUtilities.WriteLine(innerExceptionMessage ?? String.Empty);
                Assert.IsInstanceOfType(innerException, typeof(NotSupportedException));
                StringAssert.Contains(innerExceptionMessage, "'Com'");
                return;
            }
            Assert.Fail("No exception");
        }
#endif
    }
}
