﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.AlarmsAndEvents;
using OpcLabs.EasyOpc.AlarmsAndEvents.AddressSpace;
using OpcLabs.EasyOpcLiveTest.Legacy.Environment.OpcKitServer;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.Legacy.AlarmsAndEvents.AddressSpace
{
    public class AECategoryElementCollectionTest
    {

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestCategory("Live")]
        [TestMethod]
        public void BinarySerializationTestLive()
        {
            Tests.BinarySerializationTest(CreateSerializationTargetLive());
        }

        [TestCategory("Live")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTestLive()
        {
            Tests.XmlSerializationTest(CreateSerializationTargetLive());
        }

        [NotNull]
        private AECategoryElementCollection CreateSerializationTargetLive()
        {
            return EasyAEClient.SharedInstance.QueryEventCategories("", KitEventServer.ProgId, AEEventTypes.All);
        }
    }
}
