﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.DataAccess.Extensions;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.Legacy.DataAccess
{
    public class DAItemPropertyRecordTest
    {

        [TestCategory("BinarySerialization")]
        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BinarySerializationTestLive()
        {
            Tests.BinarySerializationTest(CreateSerializationTargetLive());
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTestLive()
        {
            Tests.XmlSerializationTest(CreateSerializationTargetLive());
        }

        [NotNull]
        public DAItemPropertyRecord CreateSerializationTargetLive()
        {
            return EasyDAClient.SharedInstance.GetItemPropertyRecord("", LegacyTestDefs.ProgIds.KitServer,
                LegacyTestDefs.DataAccess.ItemIds.Random);
        }
    }
}
