﻿using System;
using System.Linq;
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Collections.Specialized;
using OpcLabs.BaseLib.OperationModel;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.AddressSpace;
using OpcLabs.EasyOpc.UA.Engine;
using OpcLabs.EasyOpc.UA.OperationModel;
using OpcLabs.EasyOpc.UA.Toolkit;
using OpcLabs.EasyOpc.UA.Toolkit.ClientServer;
using OpcLabs.EasyOpcLiveTest.Legacy.UA.Environment;
using OpcLabs.EasyOpcLiveTest.UA.Environment;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.Legacy.UA.Compliance.AttributeServices
{
    public abstract partial class WriteBaseTest
    {
        // ReSharper disable InconsistentNaming
        public abstract class WriteBaseTest_Ctt : WriteBaseTest
        // ReSharper restore InconsistentNaming
        {
            [DeploymentItem("UAClientCttProjects", "UAClientCttProjects")]
            [TestClass]
            // ReSharper disable InconsistentNaming
            public class WriteBaseTest_Ctt_OpcFoundation_SampleServer_OpcTcp : WriteBaseTest_Ctt
            // ReSharper restore InconsistentNaming
            {
                public WriteBaseTest_Ctt_OpcFoundation_SampleServer_OpcTcp()
                {
                    CttProjectName = @"UAClientCttProjects\OpcFoundation_SampleServer_OpcTcp.ctt.xml";
                }
            }



            [DeploymentItem("UAClientCttProjects", "UAClientCttProjects")]
            [TestClass]
            // ReSharper disable InconsistentNaming
            public class WriteBaseTest_Ctt_Softing_DemoServer_OpcTcp : WriteBaseTest_Ctt
            // ReSharper restore InconsistentNaming
            {
                public WriteBaseTest_Ctt_Softing_DemoServer_OpcTcp()
                {
                    CttProjectName = @"UAClientCttProjects\Softing_DemoServer_OpcTcp.ctt.xml";
                }

                [ClassInitialize]
                static public void SocketPrecheck(TestContext context)
                {
                    LegacyUATestEnvironment.Current.PrecheckEndpoint(LegacyUATestEnvironment.Softing_OpcUaNetDemoServer.EndpointDescriptors.OpcTcp);
                }
            }




            #region Test Methods
            // ReSharper disable InconsistentNaming

            // 20130307 Nathan Pocock <nathan.pocock@opcfoundation.org>:
            // We currently do not test this because almost all of the clients we use are based on the .NET SDK. I would recommend 
            // leaving this functionality for now.
            ///// <description>Session should be configured to use a small body size (CreateSession MaxRequestMessageSize).
            ///// If Client permits the user to specify the nodes and values to write, then the user should pick a large number of 
            ///// items to write to in a single call.
            ///// </description>
            ///// <expectedresult>Client should obey the constraints determined from CreateSession and turn a large block-write into 
            ///// smaller write chunks.
            ///// Each chunk must be verified for correctness, and all results processed correctly.
            ///// </expectedresult>
            //[TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")]
            ////[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            ////[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            //[TestCategory("Live")]
            //[TestCategory("OpcCompliance")]
            //[TestCategory("Type:Lab")]
            //[TestMethod]
            //public void TestCase_003()
            //{
            //    // We are reusing an injection script from "Session Client Base", in order to obtain small MaxRequestMessageSize.

            //    // The Server returns a maxRequestMessageSize of 500 (bytes).
            //    using (Ctt.RunScript(CttProjectName, @"Session Services\Session Client Base\Test Cases\Err-026.js"))
            //    {
            //        const int nodeCount = 50;
            //        //const int nodeCount = 50000;    // cannot exceed 65535 due to encoding limitations
            //        const int charCount = 100;
            //        const int maxRequestMessageSize = 500;
            //        var stringValue = new string('c', charCount);
            //        UAWriteArguments[] writeArgumentsArray = UATestUtilities.MakeVolumeNodeDescriptors(nodeCount)
            //            .Select(descriptor =>
            //                // ReSharper disable AssignNullToNotNullAttribute
            //                    new UAWriteArguments(EndpointDescriptor, descriptor, new UAAttributeData(stringValue), TypeCode.String))
            //            // ReSharper restore AssignNullToNotNullAttribute
            //            .ToArray();
            //        //OperationResult[] operationResultArray = MakeClient().WriteMultiple(writeArgumentsArray);
            //        OperationResult[] operationResultArray = PerformWriteMultiple(
            //            MakeClient(),
            //            writeArgumentsArray);

            //        Assert.IsNotNull(operationResultArray);
            //        int length = operationResultArray.Length;
            //        Assert.AreEqual(nodeCount, length);
            //        CollectionAssert.AllItemsAreNotNull(operationResultArray);
            //        // TODO: test that no error is BadRequestTooLarge!
            //        int minimumChunkCount = (charCount * nodeCount - 1) / maxRequestMessageSize + 1;
            //        Debug.Assert(minimumChunkCount >= 1);
            //        if (minimumChunkCount == 1)
            //            Assert.Inconclusive();
            //        AssertUtilities.WriteLine(String.Format(CultureInfo.InvariantCulture, "minimumChunkCount: {0}", minimumChunkCount));
            //        int writeCount = WriteRecordList.Count;
            //        AssertUtilities.WriteLine(String.Format(CultureInfo.InvariantCulture, "writeCount: {0}", writeCount));
            //        Assert.IsTrue(writeCount > minimumChunkCount);
            //    }
            //}

            /// <description>Inject one of the following Service Result status codes into the response.
            /// Do this test multiple times, each time varying the code used:
            ///
            /// 1. Bad_TooManyOperations
            /// 2. Bad_NothingToDo
            /// 3. Bad_OutOfMemory.
            /// 4. Bad_InvalidArgument.
            /// 5. Bad_InternalError
            /// 6. Bad_InvalidState
            /// 7. Bad_RequestTooLarge
            /// 8. Bad_ResourceUnavailable
            /// 9. Bad_Shutdown
            /// 10. Bad_Timeout
            /// 11. Bad_UnexpectedError
            /// 12. Bad_UnknownResponse
            /// 13. Bad_UserAccessDenied 
            /// </description>
            /// <expectedresult>In the case of Bad_TooManyOperations: Client reports the error. A well-behaved client may 
            /// retransmit the write with fewer (or configurable) writes within the request. Otherwise client reports the 
            /// error to the end-user. 
            /// </expectedresult>
            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_001_01()
            {
                TestCase_Err_001(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-001-01.js",
                                 UACodeBits.BadTooManyOperations);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_001_02()
            {
                TestCase_Err_001(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-001-02.js",
                                 UACodeBits.BadNothingToDo);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_001_03()
            {
                TestCase_Err_001(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-001-03.js",
                                 UACodeBits.BadOutOfMemory);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_001_04()
            {
                TestCase_Err_001(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-001-04.js",
                                 UACodeBits.BadInvalidArgument);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_001_05()
            {
                TestCase_Err_001(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-001-05.js",
                                 UACodeBits.BadInternalError);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_001_06()
            {
                TestCase_Err_001(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-001-06.js",
                                 UACodeBits.BadInvalidState);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_001_07()
            {
                TestCase_Err_001(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-001-07.js",
                                 UACodeBits.BadRequestTooLarge);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_001_08()
            {
                TestCase_Err_001(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-001-08.js",
                                 UACodeBits.BadResourceUnavailable);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_001_09()
            {
                TestCase_Err_001(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-001-09.js",
                                 UACodeBits.BadShutdown);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_001_10()
            {
                TestCase_Err_001(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-001-10.js",
                                 UACodeBits.BadTimeout);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_001_11()
            {
                TestCase_Err_001(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-001-11.js",
                                 UACodeBits.BadUnexpectedError);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_001_12()
            {
                TestCase_Err_001(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-001-12.js",
                                 UACodeBits.BadUnknownResponse);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_001_13()
            {
                TestCase_Err_001(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-001-13.js",
                                 UACodeBits.BadUserAccessDenied);
            }

            /// <description>ServiceResult=Good.
            /// Inject one of the following Operation Level StatusCodes into the first Result. 
            /// Repeat this test several times, each time varying the code used:
            /// 
            /// 1. Bad_WriteNotSupported
            /// 2. Bad_TypeMismatch
            /// 3. Bad 
            /// 4. Good_Clamped 
            /// 5. Bad_OutOfRange 
            /// 6. Bad_TypeMismatch 
            /// 7. Bad_NodeIdUnknown 
            /// 8. Bad_NodeIdInvalid 
            /// 9. Reserved 
            /// 10.Bad_AttributeIdInvalid 
            /// 11.Bad_IndexRangeInvalid 
            /// 12.Bad_IndexRangeNoData 
            /// 13.Bad_NotWriteable 
            /// 14.Bad_UserAccessDenied 
            /// 15.Bad_DataEncodingUnsupported 
            /// 16.Good_CompletesAsynchronously
            /// </description>
            /// <expectedresult>Client processes the good results, but reports items in error to the end-user.
            /// </expectedresult>
            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_002_01()
            {
                TestCase_Err_002(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-002-01.js",
                                 UACodeBits.BadWriteNotSupported);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_002_02()
            {
                TestCase_Err_002(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-002-02.js",
                                 UACodeBits.BadTypeMismatch);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_002_03()
            {
                TestCase_Err_002(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-002-03.js",
                                 UACodeBits.BadNotSupported);   // is Bad in the description, but this is the actual code returned by the CTT script
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_002_04()
            {
                TestCase_Err_002(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-002-04.js",
                                 UACodeBits.GoodClamped);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_002_05()
            {
                TestCase_Err_002(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-002-05.js",
                                 UACodeBits.BadOutOfRange);
            }

            // note that this is a duplicate of 02
            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_002_06()
            {
                TestCase_Err_002(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-002-06.js",
                                 UACodeBits.BadTypeMismatch);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_002_07()
            {
                TestCase_Err_002(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-002-07.js",
                                 UACodeBits.BadNodeIdUnknown);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_002_08()
            {
                TestCase_Err_002(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-002-08.js",
                                 UACodeBits.BadNodeIdInvalid);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_002_09()
            {
                TestCase_Err_002(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-002-09.js",
                                 0xC000);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_002_10()
            {
                TestCase_Err_002(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-002-10.js",
                                 UACodeBits.BadAttributeIdInvalid);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_002_11()
            {
                TestCase_Err_002(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-002-11.js",
                                 UACodeBits.BadIndexRangeInvalid);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_002_12()
            {
                TestCase_Err_002(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-002-12.js",
                                 UACodeBits.BadIndexRangeNoData);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_002_13()
            {
                TestCase_Err_002(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-002-13.js",
                                 UACodeBits.BadNotWritable);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_002_14()
            {
                TestCase_Err_002(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-002-14.js",
                                 UACodeBits.BadUserAccessDenied);
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_002_15()
            {
                TestCase_Err_002(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-002-15.js",
                                 UACodeBits.BadDataEncodingUnsupported);
            }

            // the CTT script does not do what is supposed to
            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_002_16()
            {
                Ctt.ClaimScriptBuggyVersion(0xfef9cf27);
                TestCase_Err_002(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-002-16.js",
                                 UACodeBits.GoodCompletesAsynchronously);
            }

            /// <description>ServiceResult=Good.
            /// Results collection is modified as follows:
            /// 
            /// 1. Contains 1 less record than expected (size = size – 1).
            /// 2. Results are empty.
            /// 3. Collection is doubled by taking a copy of the results and then adding them onto the end of the collection. 
            /// </description>
            /// <expectedresult>Client rejects the response since the # of results do not match the # of operations. Client 
            /// indicates the situation to the user (via on-screen prompts and/or log messages etc.)”
            /// </expectedresult>
            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_003_01()
            {
                TestCase_Err_003_And_004(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-003-01.js", 
                    UACodeBits.BadUnexpectedError, "The server returned a list with less elements");
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_003_02()
            {
                Ctt.ClaimScriptBuggyVersion(0x50444824);
                TestCase_Err_003_And_004(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-003-02.js",
                    UACodeBits.BadUnexpectedError, "The server returned a list with less elements");
            }

            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_003_03()
            {
                TestCase_Err_003_And_004(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-003-03.js",
                    UACodeBits.BadUnexpectedError, "The server returned a list with more elements");
            }

            /// <description>ServiceResult = Good; StatusCode = BAD for all items.
            /// </description>
            /// <expectedresult>Client processes the good results, but reports items in error to the end-user.
            /// </expectedresult>
            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_004()
            {
                TestCase_Err_003_And_004(@"Attribute Services\Attribute Client Write Base\Test Cases\Err-004.js",
                    UACodeBits.Bad, null);
            }

            // CTT script not available
            ///// <description>Return the results encoded with UABinary when the request was for something else.
            ///// </description>
            ///// <expectedresult>Client processes the good results, but reports items in error to the end-user.
            ///// </expectedresult>
            //[TestCategory("Keyword:Write")]
            ////[TestCategory("Keyword:Array")] // we think this is incorrect
            ////[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            ////[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            //[TestCategory("Live")]
            //[TestCategory("OpcCompliance")]
            //[TestCategory("Type:CTT")]  // was Lab, corrected by us
            //[TestMethod]
            //public void TestCase_Err_005()
            //{
            //}

            // CTT script not available
            ///// <description>Return the results encoded with UAXml when the request was for something else.
            ///// </description>
            ///// <expectedresult>Client processes the good results, but reports items in error to the end-user.
            ///// </expectedresult>
            //[TestCategory("Keyword:Write")]
            ////[TestCategory("Keyword:Array")] // we think this is incorrect
            ////[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            ////[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            //[TestCategory("Live")]
            //[TestCategory("OpcCompliance")]
            //[TestCategory("Type:CTT")]  // was Lab, corrected by us
            //[TestMethod]
            //public void TestCase_Err_006()
            //{
            //}

            /// <description>Request Diagnostics information from server in Request Header but return EMPTY for the result.
            /// </description>
            /// <expectedresult>Client must be prepared for this as diagnostics are optional. But, Client reports that 
            /// no diagnostics were returned even though they were requested.
            /// </expectedresult>
            [TestCategory("Keyword:Write")]
            //[TestCategory("Keyword:Array")] // we think this is incorrect
            //[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            //[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]  // was Lab, corrected by us
            [TestMethod]
            public void TestCase_Err_009()
            {
                using (Ctt.RunScript(CttProjectName, @"Attribute Services\Attribute Client Write Base\Test Cases\Err-009.js"))
                {
                    UAWriteArguments[] writeArgumentArray =
                    {
                        //new UAReadArguments(EndpointDescriptor, UATestUtilities.MakeNodeDescriptor(typeof(float), dynamic: true))
                        new UAWriteArguments(EndpointDescriptor, new UANodeId("http://test.org/UA/Data/", "!UnknownIdentifier1"),
                            new UAAttributeData(111), typeof(int)),
                        new UAWriteArguments(EndpointDescriptor, new UANodeId("http://test.org/UA/Data/", "!UnknownIdentifier2"),
                            new UAAttributeData(222), typeof(int))
                    };
                    EasyUAClient client = MakeClient();
                    client.IsolatedParameters.SessionParameters.DiagnosticsMasks = UADiagnosticsMasks.All;
                    UAWriteResult[] writeResultArray = client.WriteMultiple(writeArgumentArray);
                    Assert.IsNotNull(writeResultArray);
                    Assert.AreEqual(writeArgumentArray.Length, writeResultArray.Length);

                    // ReSharper disable ForCanBeConvertedToForeach
                    for (int i = 0; i < writeResultArray.Length; i++)
                    // ReSharper restore ForCanBeConvertedToForeach
                    {
                        UAWriteResult result = writeResultArray[i];
                        Assert.IsNotNull(result);
                        AssertUtilities.WriteLine(result.Exception);
                        Assert.IsNotNull(result.Exception);
                        ExceptionCollection diagnostics = result.Diagnostics;
                        Assert.IsNotNull(diagnostics);
                        int count = diagnostics.Count;
                        AssertUtilities.WriteLine(count);
                        Assert.IsTrue(count >= 1);
                        CollectionAssert.AllItemsAreNotNull(diagnostics);
                        CollectionAssert.AllItemsAreUnique(diagnostics);
                        // ReSharper disable AssignNullToNotNullAttribute
                        Assert.IsTrue(diagnostics.Any(
                            exception => IsClientEngineException(exception, UAClientErrorCodes.NoDiagnosticsInfosReturned)));
                        Exception warning = diagnostics.First(
                            exception => IsClientEngineException(exception, UAClientErrorCodes.NoDiagnosticsInfosReturned));
                        // ReSharper restore AssignNullToNotNullAttribute
                        Assert.IsNotNull(warning);
                        AssertUtilities.WriteLine("Warning found:");
                        AssertUtilities.WriteLine(warning.Message);
                    }
                }
            }

            // CTT scripts appear buggy
            ///// <description>Request Diagnostics information from server in Request Header but return 
            ///// 1. More diagnostic entries than nodes requested in NodesToWrite
            ///// 2. Fewer diagnostic entries than nodes requested in NodesToWrite
            ///// </description>
            ///// <expectedresult>Client reports the mismatched # of entries returned and does not process the diagnostic infos.
            ///// </expectedresult>
            //[TestCategory("Keyword:Write")]
            ////[TestCategory("Keyword:Array")] // we think this is incorrect
            ////[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            ////[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            //[TestCategory("Live")]
            //[TestCategory("OpcCompliance")]
            //[TestCategory("Type:CTT")]  // was Lab, corrected by us
            //[TestMethod]
            //public void TestCase_Err_010_01()
            //{
            //}

            //[TestCategory("Keyword:Write")]
            ////[TestCategory("Keyword:Array")] // we think this is incorrect
            ////[TestCategory("Keyword:Diagnostics")] // we think this is incorrect
            ////[TestCategory("Keyword:Asynchronous")] // we think this is incorrect
            //[TestCategory("Live")]
            //[TestCategory("OpcCompliance")]
            //[TestCategory("Type:CTT")]  // was Lab, corrected by us
            //[TestMethod]
            //public void TestCase_Err_010_02()
            //{
            //}

            // 20130306 Nathan Pocock <nathan.pocock@opcfoundation.org>:
            ///// <description>Client writes to multiple nodes in a single call. The UACTT modifies the Server's response to return 
            ///// a different number of results, e.g. more than expected, or less than expected.</description>
            ///// <expectedresult>Client reports the mismatched # of entries returned.
            ///// Client does not process the diagnostic info, or if it does then a clear message is present that the information 
            ///// cannot be trusted.
            ///// Client should provide means for user to know (if desired) that the write was successful by the server to an 
            ///// intermediate system but that the server does not know if the ultimate data source was updated properly. Writing an entry to a log file or event log for every write is probably not practical since if this is the nature of a system, the user doesn`t need 1000`s of potentially duplicate entries.
            ///// </expectedresult>
            //public void TestCase_Err_011()
            //{
            //    //...
            //}

            // ReSharper restore InconsistentNaming
            #endregion



            #region Private Methods

            // ReSharper disable InconsistentNaming
            private void TestCase_Err_001([NotNull] string scriptName, int codeBitsExpected)
            // ReSharper restore InconsistentNaming
            {
                using (Ctt.RunScript(CttProjectName, scriptName))
                {
                    try
                    {
                        MakeClient().WriteValue(
                            EndpointDescriptor,
                            UATestUtilities.MakeNodeDescriptor(typeof(Int32), dynamic: false),
                            new Random().Next());
                    }
                    catch (UAException uaException)
                    {
                        AssertUtilities.WriteLine(uaException);
                        Exception innerException = uaException.InnerException;
                        Assert.IsNotNull(innerException);
                        var serviceException = innerException as UAServiceException;
                        Assert.IsNotNull(serviceException);

                        Assert.AreEqual(codeBitsExpected, serviceException.ServiceResult.StatusCode.CodeBits);
                        return;
                    }
                    Assert.Fail();
                }
            }

            // ReSharper disable InconsistentNaming
            private void TestCase_Err_002([NotNull] string scriptName, int codeBitsExpected)
            // ReSharper restore InconsistentNaming
            {
                using (Ctt.RunScript(CttProjectName, scriptName))
                {
                    var argumentArray = new[]
                    {
                        new UAWriteValueArguments(EndpointDescriptor,
                            UATestUtilities.MakeNodeDescriptor(typeof(Int32), dynamic: false),
                            111), 
                        new UAWriteValueArguments(EndpointDescriptor,
                            UATestUtilities.MakeNodeDescriptor(typeof(Single), dynamic: false),
                            22.2f), 
                        new UAWriteValueArguments(EndpointDescriptor,
                            UATestUtilities.MakeNodeDescriptor(typeof(String), dynamic: false),
                            "Abc")
                    };

                    UAWriteResult[] resultArray = MakeClient().WriteMultipleValues(argumentArray);
                    Assert.IsNotNull(resultArray);

                    UAWriteResult result0 = resultArray[0];
                    Assert.IsNotNull(result0);
                    Exception exception = result0.Exception;
                    AssertUtilities.WriteLine(exception);
                    switch (codeBitsExpected)
                    {
                        case UACodeBits.GoodClamped:
                            Assert.IsNull(exception);
                            AssertUtilities.WriteLine(result0);
                            Assert.IsTrue(result0.Clamped);
                            break;
                        case UACodeBits.GoodCompletesAsynchronously:
                            Assert.IsNull(exception);
                            AssertUtilities.WriteLine(result0);
                            Assert.IsTrue(result0.CompletesAsynchronously);
                            break;
                        default:
                            Assert.IsNotNull(exception);
                            var serviceException = exception as UAServiceException;
                            Assert.IsNotNull(serviceException);
                            Assert.AreEqual(codeBitsExpected, serviceException.ServiceResult.StatusCode.CodeBits);
                            break;
                    }

                    OperationResult result1 = resultArray[1];
                    Assert.IsNotNull(result1);
                    AssertUtilities.WriteLine(result1.Exception);
                    Assert.IsNull(result1.Exception);

                    OperationResult result2 = resultArray[2];
                    Assert.IsNotNull(result2);
                    AssertUtilities.WriteLine(result2.Exception);
                    Assert.IsNull(result2.Exception);
                }
            }

            // ReSharper disable InconsistentNaming
            private void TestCase_Err_003_And_004([NotNull] string scriptName, int codeBitsExpected,
                [CanBeNull] string startsWithExpected)
            // ReSharper restore InconsistentNaming
            {
                using (
                    Ctt.RunScript(CttProjectName, scriptName))
                {
                    var argumentArray = new[]
                        {
                            new UAWriteValueArguments(EndpointDescriptor,
                                                      UATestUtilities.MakeNodeDescriptor(typeof (Int32), dynamic: false),
                                                      111),
                            new UAWriteValueArguments(EndpointDescriptor,
                                                      UATestUtilities.MakeNodeDescriptor(typeof (Single), dynamic: false),
                                                      22.2f),
                            new UAWriteValueArguments(EndpointDescriptor,
                                                      UATestUtilities.MakeNodeDescriptor(typeof (String), dynamic: false),
                                                      "Abc")
                        };

                    UAWriteResult[] resultArray = MakeClient().WriteMultipleValues(argumentArray);
                    Assert.IsNotNull(resultArray);
                    Assert.AreEqual(argumentArray.Length, resultArray.Length);

                    // ReSharper disable ForCanBeConvertedToForeach
                    for (int i = 0; i < resultArray.Length; i++)
                    // ReSharper restore ForCanBeConvertedToForeach
                    {
                        UAWriteResult result = resultArray[i];
                        Assert.IsNotNull(result);
                        AssertUtilities.WriteLine(result);
                        AssertServiceException(result.Exception, codeBitsExpected, startsWithExpected);
                    }
                }
            }

            #endregion
        }
    }
}
