﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.OperationModel;
using OpcLabs.UnitTestLib;

//using OpcLabs.EasyOpc.UA;

namespace OpcLabs.EasyOpcLiveTest.Legacy.UA.Compliance.AttributeServices
{
    public abstract partial class WriteQualityAndTimestampTest
    {
        [DeploymentItem("UAClientCttProjects", "UAClientCttProjects")]
        [TestClass]
        // ReSharper disable InconsistentNaming
        public class WriteQualityAndTimestampTest_Ctt_OpcFoundation_SampleServer_OpcTcp : WriteQualityAndTimestampTest_Ctt
        // ReSharper restore InconsistentNaming
        {
            public WriteQualityAndTimestampTest_Ctt_OpcFoundation_SampleServer_OpcTcp()
            {
                CttProjectName = @"UAClientCttProjects\OpcFoundation_SampleServer_OpcTcp.ctt.xml";
            }
        }



        [DeploymentItem("UAClientCttProjects", "UAClientCttProjects")]
        [TestClass]
        // ReSharper disable InconsistentNaming
        public class WriteQualityAndTimestampTest_Ctt_Softing_DemoServer_Http : WriteQualityAndTimestampTest_Ctt
        // ReSharper restore InconsistentNaming
        {
            public WriteQualityAndTimestampTest_Ctt_Softing_DemoServer_Http()
            {
                CttProjectName = @"UAClientCttProjects\Softing_DemoServer_OpcTcp.ctt.xml";
            }
        }



        // ReSharper disable InconsistentNaming
        public abstract class WriteQualityAndTimestampTest_Ctt : WriteQualityAndTimestampTest
        // ReSharper restore InconsistentNaming
        {
            #region Test Methods
            // ReSharper disable InconsistentNaming

            // CTT script unavailable
            ///// <description>Randomly inject with the service result codes for the first item.
            /////
            ///// 1.Bad_WriteNotSupported 
            ///// 2.Bad_BadTypeMismatch 
            ///// </description>
            ///// <expectedresult>
            ///// </expectedresult>
            //[TestCategory("Keyword:Write")] // inferred
            //[TestCategory("Live")]
            //TestCategory("OpcCompliance")]
            //[TestCategory("Type:CTT")]  // inferred
            //[TestMethod]
            //public void TestCase_Err_001_01()
            //{
            //    TestCase_Err_001(@"Attribute Services\Attribute Client Write Quality & TimeStamp\Test Cases\Err-001-01.js", 
            //        UACodeBits.BadWriteNotSupported);
            //}

            //[TestCategory("Keyword:Write")] // inferred
            //[TestCategory("Live")]
            //[TestCategory("OpcCompliance")]
            //[TestCategory("Type:CTT")]  // inferred
            //[TestMethod]
            //public void TestCase_Err_001_02()
            //{
            //    TestCase_Err_001(@"Attribute Services\Attribute Client Write Quality & TimeStamp\Test Cases\Err-001-02.js",
            //        UACodeBits.BadTypeMismatch);
            //}

            // ReSharper restore InconsistentNaming
            #endregion



            #region Private Methods

            // ReSharper disable InconsistentNaming
            private void TestCase_Err_001([NotNull] string scriptName, int codeBitsExpected)
            // ReSharper restore InconsistentNaming
            {
                using (Ctt.RunScript(CttProjectName, scriptName))
                {
                    UAWriteArguments[] writeArgumentArray =
                    {
                        new UAWriteArguments(EndpointDescriptor, UATestUtilities.MakeNodeDescriptor(typeof(int), dynamic:false),
                            new UAAttributeData(111), typeof(int)),
                        new UAWriteArguments(EndpointDescriptor, UATestUtilities.MakeNodeDescriptor(typeof(float), dynamic:false),
                            new UAAttributeData(222.222), typeof(float))
                    };
                    EasyUAClient client = MakeClient();
                    UAWriteResult[] writeResultArray = client.WriteMultiple(writeArgumentArray);
                    Assert.IsNotNull(writeResultArray);
                    Assert.AreEqual(2, writeResultArray.Length);

                    UAWriteResult result0 = writeResultArray[0];
                    Assert.IsNotNull(result0);
                    AssertUtilities.WriteLine(result0.Exception);
                    Assert.IsNotNull(result0.Exception);

                    var serviceException = result0.Exception as UAServiceException;
                    Assert.IsNotNull(serviceException);
                    Assert.AreEqual(codeBitsExpected, serviceException.ServiceResult.StatusCode.CodeBits);

                    UAWriteResult result1 = writeResultArray[1];
                    Assert.IsNotNull(result1);
                    AssertUtilities.WriteLine(result1.Exception);
                    Assert.IsNull(result1.Exception);
                }
            }

            #endregion
        }
    }
}
