﻿// $Header: $
// Copyright (c) CODE Consulting and Development, s.r.o., Plzen. All rights reserved.

using System.Diagnostics;
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Opc.Ua;

namespace OpcLabs.EasyOpcLiveTest.Legacy.UA.Compliance.DataAccess
{
    public partial class BasicTest : EndpointTestBase
    {
        #region Static Private Methods

#if (NETFRAMEWORK)
        static private void AssertAbsoluteDeadband([NotNull] UAOperationRecorder recorder, double deadbandValue)
        {
            Assert.AreEqual(1, recorder.CreateMonitoredItemsRecordList.Count - UATestUtilities.BuiltInCreateMonitoredItemsCount);
            CreateMonitoredItemsRecord record = recorder.CreateMonitoredItemsRecordList[UATestUtilities.BuiltInCreateMonitoredItemsCount];
            Debug.Assert(record != null);
            MonitoredItemCreateRequestCollection sdkItemsToCreate = record.ItemsToCreate;
            Assert.IsNotNull(sdkItemsToCreate);
            Assert.AreEqual(1, sdkItemsToCreate.Count);
            MonitoredItemCreateRequest sdkRequest = sdkItemsToCreate[0];
            Assert.IsNotNull(sdkRequest);
            MonitoringParameters sdkRequestedParameters = sdkRequest.RequestedParameters;
            Assert.IsNotNull(sdkRequestedParameters);
            ExtensionObject sdkFilter = sdkRequestedParameters.Filter;
            Assert.IsNotNull(sdkFilter);
            object sdkBody = sdkFilter.Body;
            Assert.IsNotNull(sdkBody);
            var sdkDataChangeFilter = sdkBody as DataChangeFilter;
            Assert.IsNotNull(sdkDataChangeFilter);
            Assert.AreEqual((uint)DeadbandType.Absolute, sdkDataChangeFilter.DeadbandType);
            Assert.AreEqual(deadbandValue, sdkDataChangeFilter.DeadbandValue);
        }
#endif

#endregion



#region Private Methods

#endregion
    }
}
