﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpcLiveTest.UA.Environment;

namespace OpcLabs.EasyOpcLiveTest.Legacy.UA.Compliance.DiscoveryServices
{
    public partial class FindServersBasicTest
    {
        // ReSharper disable InconsistentNaming
        public class FindServersBasicTest_NoCtt : FindServersBasicTest
        // ReSharper restore InconsistentNaming
        {
            #region Test Methods
// ReSharper disable InconsistentNaming

///// <description>Connect to discovery server which requires SSL/TLS.
///// Note: protocol is https
///// </description>
///// <expectedresult>
///// Verify that the Client uses its application instance certificate as the SSL/TLS client certificate.
///// </expectedresult>
//[TestCategory("Keyword:ActivateSession")]
//[TestCategory("Live")]
//[TestCategory("OpcCompliance")]
//[TestCategory("Type:Lab")]
//[TestMethod]
//public void TestCase_010()
//{
//    EasyUAClient client = MakeClient();
//    client.IsolatedHostParameters.DiscoveryUriTemplateStrings = new [] { 
//        String.Format(CultureInfo.InvariantCulture, UAHostParameters.UriTemplateStringFormat,
//                                            Uri.UriSchemeHttps, 443, "UADiscovery") };

//    client.DiscoverLocalServers();
//}

#if (NETFRAMEWORK)
            [TestCategory("Keyword:FindServers")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_008_Inverted()
            {
                TestCase_Err_008(true);
            }
#endif

#if (NETFRAMEWORK)
            [TestCategory("Keyword:FindServers")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_009_Inverted()
            {
                TestCase_Err_009(true);
            }
#endif

#if (NETFRAMEWORK)
            [TestCategory("Keyword:FindServers")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_010_Inverted()
            {
                TestCase_Err_010(true);
            }
#endif

#if (NETFRAMEWORK)
            [TestCategory("Keyword:FindServers")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_011_Inverted()
            {
                TestCase_Err_011(true);
            }
#endif

#if (NETFRAMEWORK)
            [TestCategory("Keyword:FindServers")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_013_Inverted()
            {
                TestCase_Err_013_And_016(true, @"Discovery Services\Discovery Client Find Servers Basic\Test Cases\Err-013.js");
            }
#endif

#if (NETFRAMEWORK)
            [TestCategory("Keyword:FindServers")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_014_Inverted()
            {
                TestCase_Err_014(true);
            }
#endif

#if (NETFRAMEWORK)
            [TestCategory("Keyword:FindServers")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_016_Inverted()
            {
                TestCase_Err_013_And_016(true, @"Discovery Services\Discovery Client Find Servers Basic\Test Cases\Err-016.js");
            }
#endif

            // ReSharper restore InconsistentNaming
#endregion
        }



        [TestClass]
        // ReSharper disable InconsistentNaming
        public class FindServersBasicTest_NoCtt_OpcFoundation_SampleServer_OpcTcp : FindServersBasicTest_NoCtt
        // ReSharper restore InconsistentNaming
        {
            public FindServersBasicTest_NoCtt_OpcFoundation_SampleServer_OpcTcp()
            {
                EndpointDescriptorDirect = LegacyUATestEnvironment.OpcFoundation_SampleServer.EndpointDescriptors.OpcTcp;
            }

            [ClassInitialize]
            static public void SocketPrecheck(TestContext context)
            {
                LegacyUATestEnvironment.Current.PrecheckEndpoint(LegacyUATestEnvironment.OpcFoundation_SampleServer.EndpointDescriptors.OpcTcp);
            }



#region Test Methods
            // ReSharper disable InconsistentNaming

            // ReSharper restore InconsistentNaming
#endregion
        }



        [TestClass]
        // ReSharper disable InconsistentNaming
        public class FindServersBasicTest_NoCtt_Softing_DemoServer_Http : FindServersBasicTest_NoCtt
        // ReSharper restore InconsistentNaming
        {
            public FindServersBasicTest_NoCtt_Softing_DemoServer_Http()
            {
                EndpointDescriptorDirect = LegacyUATestEnvironment.Softing_OpcUaNetDemoServer.EndpointDescriptors.Http;
            }

            [ClassInitialize]
            static public void SocketPrecheck(TestContext context)
            {
                LegacyUATestEnvironment.Current.PrecheckEndpoint(LegacyUATestEnvironment.Softing_OpcUaNetDemoServer.EndpointDescriptors.Http);
            }
        }



        [TestClass]
        // ReSharper disable InconsistentNaming
        public class FindServersBasicTest_NoCtt_Softing_DemoServer_OpcTcp : FindServersBasicTest_NoCtt
        // ReSharper restore InconsistentNaming
        {
            public FindServersBasicTest_NoCtt_Softing_DemoServer_OpcTcp()
            {
                EndpointDescriptorDirect = LegacyUATestEnvironment.Softing_OpcUaNetDemoServer.EndpointDescriptors.OpcTcp;
            }

            [ClassInitialize]
            static public void SocketPrecheck(TestContext context)
            {
                LegacyUATestEnvironment.Current.PrecheckEndpoint(LegacyUATestEnvironment.Softing_OpcUaNetDemoServer.EndpointDescriptors.OpcTcp);
            }
        }
    }
}
