﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA.Toolkit.Diagnostics;
using OpcLabs.EasyOpcLiveTest.UA.Environment;

namespace OpcLabs.EasyOpcLiveTest.Legacy.UA.Compliance.DiscoveryServices
{
    public partial class GetEndpointsBasicTest
    {
        // ReSharper disable InconsistentNaming
        public class GetEndpointsBasicTest_NoCtt : GetEndpointsBasicTest
        // ReSharper restore InconsistentNaming
        {
            #region Test Methods
            // ReSharper disable InconsistentNaming

            [TestCategory("Keyword:GetEndpoints")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_006_alpha_Inverted()
            {
                TestCase_Err_006_alpha(inverted: true);
            }

            [TestCategory("Keyword:GetEndpoints")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_007_Inverted()
            {
                Test_Err_003_To_013(true, @"Discovery Services\Discovery Client Get Endpoints Basic\Test Cases\Err-007.js",
                    UAEngineEventIds.EndpointDescriptionApplicationUriNullOrEmpty);
            }

            [TestCategory("Keyword:GetEndpoints")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_008_Inverted()
            {
                Test_Err_003_To_013(true, @"Discovery Services\Discovery Client Get Endpoints Basic\Test Cases\Err-008.js",
                    UAEngineEventIds.EndpointDescriptionDiscoveryUrlsEmpty);
            }

            [TestCategory("Keyword:GetEndpoints")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_009_Inverted()
            {
                Test_Err_003_To_013(true, @"Discovery Services\Discovery Client Get Endpoints Basic\Test Cases\Err-009.js",
                    UAEngineEventIds.EndpointDescriptionServerNullOrEmpty);
            }

            [TestCategory("Keyword:GetEndpoints")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_010_Inverted()
            {
                Test_Err_003_To_013(true, @"Discovery Services\Discovery Client Get Endpoints Basic\Test Cases\Err-010.js",
                    UAEngineEventIds.EndpointDescriptionApplicationTypeClient);
            }

            [TestCategory("Keyword:GetEndpoints")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_011_Inverted()
            {
                Test_Err_003_To_013(true, @"Discovery Services\Discovery Client Get Endpoints Basic\Test Cases\Err-011.js",
                    UAEngineEventIds.EndpointDescriptionApplicationTypeClient);
            }

            [TestCategory("Keyword:GetEndpoints")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_012_Inverted()
            {
                Test_Err_003_To_013(true, @"Discovery Services\Discovery Client Get Endpoints Basic\Test Cases\Err-012.js",
                    UAEngineEventIds.EndpointDescriptionApplicationTypeClient);
            }

            [TestCategory("Keyword:GetEndpoints")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_021_Inverted()
            {
                Test_Err_021_To_031(true, @"Discovery Services\Discovery Client Get Endpoints Basic\Test Cases\Err-021.js",
                    UAEngineEventIds.EndpointDescriptionSecurityModeInvalid);
            }

            [TestCategory("Keyword:GetEndpoints")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_022_Inverted()
            {
                Test_Err_021_To_031(true, @"Discovery Services\Discovery Client Get Endpoints Basic\Test Cases\Err-022.js",
                    UAEngineEventIds.EndpointDescriptionSecurityPolicyUriEmpty);
            }

            [TestCategory("Keyword:GetEndpoints")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_023_Inverted()
            {
                Test_Err_021_To_031(true, @"Discovery Services\Discovery Client Get Endpoints Basic\Test Cases\Err-023.js",
                    UAEngineEventIds.EndpointDescriptionSecurityPolicyUriInvalid);
            }

            [TestCategory("Keyword:GetEndpoints")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_026_Inverted()
            {
                Test_Err_021_To_031(true, @"Discovery Services\Discovery Client Get Endpoints Basic\Test Cases\Err-026.js",
                    UAEngineEventIds.EndpointDescriptionIssuedTokenTypeEmpty);
            }

            [TestCategory("Keyword:GetEndpoints")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_028_Inverted()
            {
                Test_Err_021_To_031(true, @"Discovery Services\Discovery Client Get Endpoints Basic\Test Cases\Err-028.js",
                    UAEngineEventIds.EndpointDescriptionTransportProfileUriEmpty);
            }

            [TestCategory("Keyword:GetEndpoints")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_029_Inverted()
            {
                Test_Err_021_To_031(true, @"Discovery Services\Discovery Client Get Endpoints Basic\Test Cases\Err-029.js",
                    UAEngineEventIds.EndpointDescriptionTransportProfileUriInvalid);
            }

            // we end up selecting this endpoint anyway
            //[TestCategory("Keyword:GetEndpoints")]
            //[TestCategory("Live")]
            //[TestCategory("OpcCompliance")]
            //[TestMethod]
            //public void TestCase_Err_032_Inverted()
            //{
            //    // IMPROVE: it may be an accident that this test passes. It is different from the others.
            //    Test_Err_021_To_031(true, @"Discovery Services\Discovery Client Get Endpoints Basic\Test Cases\Err-032.js",
            //        UAEngineEventIds.SelectedEndpointWithZeroSecurityLevel);
            //}

            // ReSharper restore InconsistentNaming
            #endregion
        }



        [TestClass]
        // ReSharper disable InconsistentNaming
        public class GetEndpointsBasicTest_NoCtt_OpcFoundation_SampleServer_OpcTcp : GetEndpointsBasicTest_NoCtt
        // ReSharper restore InconsistentNaming
        {
            public GetEndpointsBasicTest_NoCtt_OpcFoundation_SampleServer_OpcTcp()
            {
                EndpointDescriptorDirect = LegacyUATestEnvironment.OpcFoundation_SampleServer.EndpointDescriptors.OpcTcp;
            }

            [ClassInitialize]
            static public void SocketPrecheck(TestContext context)
            {
                LegacyUATestEnvironment.Current.PrecheckEndpoint(LegacyUATestEnvironment.OpcFoundation_SampleServer.EndpointDescriptors.OpcTcp);
            }



            #region Test Methods
            // ReSharper disable InconsistentNaming

            // ReSharper restore InconsistentNaming
            #endregion
        }



        [TestClass]
        // ReSharper disable InconsistentNaming
        public class GetEndpointsBasicTest_NoCtt_Softing_DemoServer_Http : GetEndpointsBasicTest_NoCtt
        // ReSharper restore InconsistentNaming
        {
            public GetEndpointsBasicTest_NoCtt_Softing_DemoServer_Http()
            {
                EndpointDescriptorDirect = LegacyUATestEnvironment.Softing_OpcUaNetDemoServer.EndpointDescriptors.Http;
            }

            [ClassInitialize]
            static public void SocketPrecheck(TestContext context)
            {
                LegacyUATestEnvironment.Current.PrecheckEndpoint(LegacyUATestEnvironment.Softing_OpcUaNetDemoServer.EndpointDescriptors.Http);
            }
        }



        [TestClass]
        // ReSharper disable InconsistentNaming
        public class GetEndpointsBasicTest_NoCtt_Softing_DemoServer_OpcTcp : GetEndpointsBasicTest_NoCtt
        // ReSharper restore InconsistentNaming
        {
            public GetEndpointsBasicTest_NoCtt_Softing_DemoServer_OpcTcp()
            {
                EndpointDescriptorDirect = LegacyUATestEnvironment.Softing_OpcUaNetDemoServer.EndpointDescriptors.OpcTcp;
            }

            [ClassInitialize]
            static public void SocketPrecheck(TestContext context)
            {
                LegacyUATestEnvironment.Current.PrecheckEndpoint(LegacyUATestEnvironment.Softing_OpcUaNetDemoServer.EndpointDescriptors.OpcTcp);
            }
        }
    }
}
