﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Instrumentation;
using OpcLabs.EasyOpc.UA.Toolkit.Diagnostics;
using OpcLabs.EasyOpcLiveTest.UA.Environment;

namespace OpcLabs.EasyOpcLiveTest.Legacy.UA.Compliance.MonitoredItemServices
{
    public partial class ModifyTest
    {
        [TestClass]   // currently CTT does not inject the changes as it should
        // ReSharper disable InconsistentNaming
        public class ModifyTest_NoCtt_OpcFoundation_SampleServer_OpcTcp : ModifyTest_NoCtt
        // ReSharper restore InconsistentNaming
        {
            public ModifyTest_NoCtt_OpcFoundation_SampleServer_OpcTcp()
            {
                EndpointDescriptorDirect = LegacyUATestEnvironment.OpcFoundation_SampleServer.EndpointDescriptors.OpcTcp;
            }

            [ClassInitialize]
            static public void SocketPrecheck(TestContext context)
            {
                LegacyUATestEnvironment.Current.PrecheckEndpoint(LegacyUATestEnvironment.OpcFoundation_SampleServer.EndpointDescriptors.OpcTcp);
            }
        }



        [TestClass]   // currently CTT does not inject the changes as it should
        // ReSharper disable InconsistentNaming
        public class ModifyTest_NoCtt_Softing_DemoServer_OpcTcp : ModifyTest_NoCtt
        // ReSharper restore InconsistentNaming
        {
            public ModifyTest_NoCtt_Softing_DemoServer_OpcTcp()
            {
                EndpointDescriptorDirect = LegacyUATestEnvironment.Softing_OpcUaNetDemoServer.EndpointDescriptors.OpcTcp;
            }

            [ClassInitialize]
            static public void SocketPrecheck(TestContext context)
            {
                LegacyUATestEnvironment.Current.PrecheckEndpoint(LegacyUATestEnvironment.Softing_OpcUaNetDemoServer.EndpointDescriptors.OpcTcp);
            }
        }



        // ReSharper disable InconsistentNaming
        public class ModifyTest_NoCtt : ModifyTest
        // ReSharper restore InconsistentNaming
        {
            #region Test Methods
// ReSharper disable InconsistentNaming

#if (NETFRAMEWORK)
            [TestCategory("Keyword:ModifyMonitoredItems")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_005_01_Inverted()
            {
                TestCase_Err_005(true, @"Monitored Item Services\Monitor Client Modify\Test Cases\Err-005-01.js",
                                 UAEngineEventIds.RevisedQueueSizeDifferent, LogEntryType.Information);
            }

            [TestCategory("Keyword:ModifyMonitoredItems")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_005_02_Inverted()
            {
                TestCase_Err_005(true, @"Monitored Item Services\Monitor Client Modify\Test Cases\Err-005-02.js",
                                 UAEngineEventIds.RevisedQueueSizeAboveToleranceRange, LogEntryType.Information);
            }

            // Our test servers revise the queue size to 0 incorrectly
            //[TestCategory("Keyword:ModifyMonitoredItems")]
            //[TestCategory("Live")]
            //[TestCategory("OpcCompliance")]
            //[TestMethod]
            //public void TestCase_Err_005_03_Inverted()
            //{
            //    TestCase_Err_005(true, @"Monitored Item Services\Monitor Client Modify\Test Cases\Err-005-03.js",
            //                     UAEngineEventIds.RevisedQueueSizeInvalid, LogEntryType.Warning);
            //}
#endif

#if (NETFRAMEWORK)
            [TestCategory("Keyword:DeleteMonitoredItems")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_012_01_Inverted()
            {
                TestCase_Err_012(true, @"Monitored Item Services\Monitor Client Modify\Test Cases\Err-012-01.js",
                                 UAEngineEventIds.SubscriptionPerformChangesFailure, LogEntryType.Warning);
            }

            [TestCategory("Keyword:CreateMonitoredItems")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_012_02_Inverted()
            {
                TestCase_Err_012(true, @"Monitored Item Services\Monitor Client Modify\Test Cases\Err-012-02.js",
                                 UAEngineEventIds.SubscriptionPerformChangesFailure, LogEntryType.Warning);
            }

            [TestCategory("Keyword:CreateMonitoredItems")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_012_03_Inverted()
            {
                TestCase_Err_012(true, @"Monitored Item Services\Monitor Client Modify\Test Cases\Err-012-03.js",
                                 UAEngineEventIds.SubscriptionPerformChangesFailure, LogEntryType.Warning);
            }

            [TestCategory("Keyword:CreateMonitoredItems")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_012_04_Inverted()
            {
                TestCase_Err_012(true, @"Monitored Item Services\Monitor Client Modify\Test Cases\Err-012-04.js",
                                 UAEngineEventIds.MonitoredItemDeleteError, LogEntryType.Information);
            }

            [TestCategory("Keyword:CreateMonitoredItems")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestMethod]
            public void TestCase_Err_012_05_Inverted()
            {
                TestCase_Err_012(true, @"Monitored Item Services\Monitor Client Modify\Test Cases\Err-012-05.js",
                                 UAEngineEventIds.MonitoredItemDeleteError, LogEntryType.Information);
            }
#endif

            // ReSharper restore InconsistentNaming
#endregion
        }
    }
}
