﻿// $Header: $
// Copyright (c) CODE Consulting and Development, s.r.o., Plzen. All rights reserved.

using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Instrumentation;
using OpcLabs.EasyOpc.UA;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.Legacy.UA.Compliance.MonitoredItemServices
{
    public partial class ValueChangeTest : EndpointTestBase
    {
        #region Protected Methods

#if (NETFRAMEWORK)
        // ReSharper disable InconsistentNaming
        protected void TestCase_Err_006(
            // ReSharper restore InconsistentNaming
            bool inverted,
            [NotNull] string scriptName,
            int eventIdExpected,
            LogEntryType entryTypeExpected)
        {
            var logEntryEventArgsListQueue = new ConcurrentQueue<LogEntryEventArgs>();
            EasyUAClient.LogEntry += (sender, args) => logEntryEventArgsListQueue.Enqueue(args);

            using (inverted ? null : Ctt.RunScript(CttProjectName, scriptName))
            {
                var monitoredItemArguments = MakeMonitoredItemArguments(typeof(Int32), dynamic: false);
                //IEnumerable<EasyUAMonitoredItemChangedEventArgs> eventArgsEnumerable =
                CollectMonitoredItemChangedEventArgs(
                    MakeClient(),
                    monitoredItemArguments,
                    MillisecondsToCollectSingleNotification);
            }
            AssertUtilities.WriteSeparatorLine();

            var logEntryEventArgsList = new List<LogEntryEventArgs>(logEntryEventArgsListQueue);
            // ReSharper disable PossibleNullReferenceException
            LogEntryEventArgs logEntryEventArgs = logEntryEventArgsList.Find(args =>
                (args.EventId == eventIdExpected));
            // ReSharper restore PossibleNullReferenceException

            if (inverted)
            {
                Assert.IsNull(logEntryEventArgs);
                return;
            }

            Assert.IsNotNull(logEntryEventArgs);
            AssertUtilities.WriteLine(logEntryEventArgs.Message);
            Assert.AreEqual(entryTypeExpected, logEntryEventArgs.EntryType);

            // IMPROVE:
            // EasyUAMonitoredItemChangedEventArgs eventArgs0 = AssertAndGetSingleEventArgs(eventArgsEnumerable);
            // Assert...
        }
#endif

#endregion
    }
}
