﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Instrumentation;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.Toolkit.Diagnostics;
using OpcLabs.EasyOpcLiveTest.UA.Environment;

namespace OpcLabs.EasyOpcLiveTest.Legacy.UA.Compliance.SubscriptionServices
{
    // ReSharper disable InconsistentNaming
    public class BasicTest_NoCtt : BasicTest
    // ReSharper restore InconsistentNaming
    {
        [TestClass]
        // ReSharper disable InconsistentNaming
        public class BasicTest_NoCtt_OpcFoundation_SampleServer_OpcTcp : BasicTest_NoCtt
        // ReSharper restore InconsistentNaming
        {
            public BasicTest_NoCtt_OpcFoundation_SampleServer_OpcTcp()
            {
                EndpointDescriptorDirect = LegacyUATestEnvironment.OpcFoundation_SampleServer.EndpointDescriptors.OpcTcp;
            }

            [ClassInitialize]
            static public void SocketPrecheck(TestContext context)
            {
                LegacyUATestEnvironment.Current.PrecheckEndpoint(LegacyUATestEnvironment.OpcFoundation_SampleServer.EndpointDescriptors.OpcTcp);
            }



            #region Test Methods
            // ReSharper disable InconsistentNaming

            // ReSharper restore InconsistentNaming
            #endregion
        }



        [TestClass]
        // ReSharper disable InconsistentNaming
        public class BasicTest_NoCtt_Softing_DemoServer_Http : BasicTest_NoCtt
        // ReSharper restore InconsistentNaming
        {
            public BasicTest_NoCtt_Softing_DemoServer_Http()
            {
                EndpointDescriptorDirect = LegacyUATestEnvironment.Softing_OpcUaNetDemoServer.EndpointDescriptors.Http;
            }

            [ClassInitialize]
            static public void SocketPrecheck(TestContext context)
            {
                LegacyUATestEnvironment.Current.PrecheckEndpoint(LegacyUATestEnvironment.Softing_OpcUaNetDemoServer.EndpointDescriptors.Http);
            }
        }



        #region Test Methods
        // ReSharper disable InconsistentNaming

        [TestCategory("Keyword:CreateSubscription")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_002_Inverted()
        {
            TestCase_Err_002(true);
        }

        [TestCategory("Keyword:CreateSubscription")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_003_01_Inverted()
        {
            TestCase_003_01(true);
        }

        [TestCategory("Keyword:CreateSubscription")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_003_02_Inverted()
        {
            TestCase_003_02(true);
        }

        [TestCategory("Keyword:CreateSubscription")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_004_01_Inverted()
        {
            TestCase_004_01(true);
        }

        [TestCategory("Keyword:CreateSubscription")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_004_02_Inverted()
        {
            TestCase_Err_004_02(true);
        }

        [TestCategory("Keyword:CreateSubscription")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_004_03_Inverted()
        {
            TestCase_Err_004_03(true);
        }

        [TestCategory("Keyword:CreateSubscription")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_005_01_Inverted()
        {
            TestCase_Err_005_01(true);
        }

        [TestCategory("Keyword:CreateSubscription")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_005_02_Inverted()
        {
            TestCase_Err_005_02(true);
        }

        [TestCategory("Keyword:Publish")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_008_01_Inverted()
        {
            TestCase_Err_008(
                true,
                @"Subscription Services\Subscription Client Basic\Test Cases\Err-008-01.js",
                UAEngineEventIds.SessionPublishError,
                LogEntryType.Warning,
                new UAStatusCode(UACodeBits.BadTooManyPublishRequests, 0));
        }

        // BadNoSubscription warnings may be legitimate
        //[TestCategory("Keyword:Publish")]
        //[TestCategory("Live")]
        //[TestCategory("OpcCompliance")]
        //[TestMethod]
        //public void TestCase_Err_008_02_Inverted()
        //{
        //    TestCase_Err_008(
        //        true,
        //        @"Subscription Services\Subscription Client Basic\Test Cases\Err-008-02.js",
        //        UAEngineEventIds.SessionPublishError,
        //        LogEntryType.Warning,
        //        new UAStatusCode(UACodeBits.BadNoSubscription, 0));
        //}

        [TestCategory("Keyword:Publish")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_009_Inverted()
        {
            TestCase_Err_Subscription(
                true,
                @"Subscription Services\Subscription Client Basic\Test Cases\Err-009.js",
                UAEngineEventIds.PublishResponseSubscriptionIdUnknown,
                LogEntryType.Warning);
        }
        [TestCategory("Keyword:Publish")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestCategory("Type:CTT")]
        [TestMethod]
        public void TestCase_Err_010_01_Inverted()
        {
            TestCase_Err_Subscription(
                true,
                @"Subscription Services\Subscription Client Basic\Test Cases\Err-010-01.js",
                UAEngineEventIds.AvailableSequenceNumberAlreadyAcknowledged,
                LogEntryType.Warning);
        }

        [TestCategory("Keyword:Publish")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestCategory("Type:CTT")]
        [TestMethod]
        public void TestCase_Err_010_02_Inverted()
        {
            TestCase_Err_Subscription(
                true,
                @"Subscription Services\Subscription Client Basic\Test Cases\Err-010-02.js",
                UAEngineEventIds.AvailableSequenceNumberAlreadyAcknowledged,
                LogEntryType.Warning);
        }

        [TestCategory("Keyword:Publish")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestCategory("Type:CTT")]
        [TestMethod]
        public void TestCase_Err_010_03_Inverted()
        {
            TestCase_Err_Subscription(
                true,
                @"Subscription Services\Subscription Client Basic\Test Cases\Err-010-03.js",
                UAEngineEventIds.AvailableSequenceNumberUnknown,
                LogEntryType.Warning);
        }

        [TestCategory("Keyword:Publish")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestCategory("Type:CTT")]
        [TestMethod]
        public void TestCase_Err_010_04_Inverted()
        {
            TestCase_Err_Subscription(
                true,
                @"Subscription Services\Subscription Client Basic\Test Cases\Err-010-04.js",
                UAEngineEventIds.AvailableSequenceNumbersEmpty,
                LogEntryType.Warning);
        }

        [TestCategory("Keyword:Publish")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_011_01_Inverted()
        {
            TestCase_Err_011(
                true,
                @"Subscription Services\Subscription Client Basic\Test Cases\Err-011-01.js",
                UAEngineEventIds.NotificationMessageEmpty,
                LogEntryType.Warning);
        }

        [TestCategory("Keyword:Publish")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_011_02_Inverted()
        {
            Ctt.ClaimScriptBuggyVersion(0x19187fea);
            TestCase_Err_011(
                true,
                @"Subscription Services\Subscription Client Basic\Test Cases\Err-011-02.js",
                UAEngineEventIds.SequenceNumberReused,
                LogEntryType.Warning);
        }

        [TestCategory("Keyword:Publish")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_012_01_Inverted()
        {
            TestCase_Err_012(
                true,
                @"Subscription Services\Subscription Client Basic\Test Cases\Err-012-01.js",
                UAEngineEventIds.PublishTimeAhead,
                LogEntryType.Information);
        }

        [TestCategory("Keyword:Publish")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_012_02_Inverted()
        {
            TestCase_Err_012(
                true,
                @"Subscription Services\Subscription Client Basic\Test Cases\Err-012-02.js",
                UAEngineEventIds.PublishTimeStale,
                LogEntryType.Information);
        }

        [TestCategory("Keyword:Publish")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_018_01_Inverted()
        {
            TestCase_Err_Subscription(
                true,
                @"Subscription Services\Subscription Client Basic\Test Cases\Err-018-01.js",
                UAEngineEventIds.NotificationAcknowledgeError,
                LogEntryType.Warning,
                new UAStatusCode(UACodeBits.BadSubscriptionIdInvalid, 0));
        }

        [TestCategory("Keyword:Publish")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_018_02_Inverted()
        {
            TestCase_Err_Subscription(
                true,
                @"Subscription Services\Subscription Client Basic\Test Cases\Err-018-02.js",
                UAEngineEventIds.NotificationAcknowledgeError,
                LogEntryType.Warning,
                new UAStatusCode(UACodeBits.BadSequenceNumberUnknown, 0));
        }

        [TestCategory("Keyword:Publish")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_018_03_Inverted()
        {
            TestCase_Err_Subscription(
                true,
                @"Subscription Services\Subscription Client Basic\Test Cases\Err-018-03.js",
                UAEngineEventIds.NotificationAcknowledgeError,
                LogEntryType.Warning,
                new UAStatusCode(UACodeBits.BadSequenceNumberInvalid, 0));
        }

        [TestCategory("Keyword:Publish")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_018_05_Inverted()
        {
            TestCase_Err_Subscription(
                true,
                @"Subscription Services\Subscription Client Basic\Test Cases\Err-018-05.js",
                UAEngineEventIds.NotificationAcknowledgeError,
                LogEntryType.Warning,
                (Ctt.ScriptCrc == 0x7c743fe3)
                    ? new UAStatusCode(UACodeBits.BadSubscriptionIdInvalid, 0)
                    : new UAStatusCode(UACodeBits.BadSequenceNumberInvalid, 0));
        }

        [TestCategory("Keyword:DataChangeNotification")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_020_Inverted()
        {
            TestCase_Err_020(true);
        }

        [TestCategory("Keyword:DataChangeNotification")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_021_01_Inverted()
        {
            TestCase_Err_021_01(true);
        }

        [TestCategory("Keyword:DataChangeNotification")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_022_02_Inverted()
        {
            TestCase_Err_022_02(true);
        }

        [TestCategory("Keyword:DataChangeNotification")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_023_Inverted()
        {
            TestCase_Err_023(true);
        }

        // ReSharper restore InconsistentNaming
        #endregion



        #region Private Methods

        #endregion
    }
}
