﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Instrumentation;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.Toolkit.Diagnostics;
using OpcLabs.EasyOpcLiveTest.Legacy.UA.Environment;
using OpcLabs.EasyOpcLiveTest.UA.Environment;

namespace OpcLabs.EasyOpcLiveTest.Legacy.UA.Compliance.SubscriptionServices
{
    public abstract partial class ModifyTest
    {
        // ReSharper disable InconsistentNaming
        public abstract class ModifyTestCtt : ModifyTest
        // ReSharper restore InconsistentNaming
        {
            [DeploymentItem("UAClientCttProjects", "UAClientCttProjects")]
            [TestClass]
            // ReSharper disable InconsistentNaming
            public class ModifyTest_Ctt_OpcFoundationSampleServer_OpcTcp : ModifyTestCtt
            // ReSharper restore InconsistentNaming
            {
                public ModifyTest_Ctt_OpcFoundationSampleServer_OpcTcp()
                {
                    CttProjectName = @"UAClientCttProjects\OpcFoundation_SampleServer_OpcTcp.ctt.xml";
                }
            }



            [DeploymentItem("UAClientCttProjects", "UAClientCttProjects")]
            [TestClass]
            // ReSharper disable InconsistentNaming
            public class ModifyTest_Ctt_SoftingDemoServer_OpcTcp : ModifyTestCtt
            // ReSharper restore InconsistentNaming
            {
                public ModifyTest_Ctt_SoftingDemoServer_OpcTcp()
                {
                    CttProjectName = @"UAClientCttProjects\Softing_DemoServer_OpcTcp.ctt.xml";
                }

                [ClassInitialize]
                static public void SocketPrecheck(TestContext context)
                {
                    LegacyUATestEnvironment.Current.PrecheckEndpoint(LegacyUATestEnvironment.Softing_OpcUaNetDemoServer.EndpointDescriptors.OpcTcp);
                }
            }




            #region Test Methods
            // ReSharper disable InconsistentNaming

            /// <description>
            /// Inject the following ServiceResults codes 
            /// 1. ServiceResult = Bad_NothingToDo
            /// 2. ServiceResult = Bad_TooManyOperations
            /// </description>
            /// <expectedresult>
            /// Client logs and/or displays an error to the end-user.
            /// Client assumes that no/zero subscriptions have been deleted.
            /// </expectedresult>
            [TestCategory("Keyword:DeleteSubscription")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]
            [TestMethod]
            public void TestCase_Err_012_01()
            {
                TestCase_Err_Subscription(
                    false,
                    @"Subscription Services\Subscription Client Modify\Test Cases\Err-012-01.js",
                    UAEngineEventIds.SubscriptionRemoveFailure,
                    LogEntryType.Warning,
                    new UAStatusCode(UACodeBits.BadNothingToDo, 0));
            }

            [TestCategory("Keyword:DeleteSubscription")]
            [TestCategory("Live")]
            [TestCategory("OpcCompliance")]
            [TestCategory("Type:CTT")]
            [TestMethod]
            public void TestCase_Err_012_02()
            {
                TestCase_Err_Subscription(
                    false,
                    @"Subscription Services\Subscription Client Modify\Test Cases\Err-012-02.js",
                    UAEngineEventIds.SubscriptionRemoveFailure,
                    LogEntryType.Warning,
                    new UAStatusCode(UACodeBits.BadTooManyOperations, 0));
            }

            // ReSharper restore InconsistentNaming
            #endregion



            #region Private Methods

            #endregion
        }
    }
}
