﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Instrumentation;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.Toolkit.Diagnostics;
using OpcLabs.EasyOpcLiveTest.UA.Environment;

namespace OpcLabs.EasyOpcLiveTest.Legacy.UA.Compliance.SubscriptionServices
{
    // ReSharper disable InconsistentNaming
    public class ModifyTest_NoCtt : ModifyTest
    // ReSharper restore InconsistentNaming
    {
        [TestClass]
        // ReSharper disable InconsistentNaming
        public class ModifyTest_NoCtt_OpcFoundation_SampleServer_OpcTcp : ModifyTest_NoCtt
        // ReSharper restore InconsistentNaming
        {
            public ModifyTest_NoCtt_OpcFoundation_SampleServer_OpcTcp()
            {
                EndpointDescriptorDirect = LegacyUATestEnvironment.OpcFoundation_SampleServer.EndpointDescriptors.OpcTcp;
            }

            [ClassInitialize]
            static public void SocketPrecheck(TestContext context)
            {
                LegacyUATestEnvironment.Current.PrecheckEndpoint(LegacyUATestEnvironment.OpcFoundation_SampleServer.EndpointDescriptors.OpcTcp);
            }



            #region Test Methods
            // ReSharper disable InconsistentNaming

            // ReSharper restore InconsistentNaming
            #endregion
        }



        [TestClass]
        // ReSharper disable InconsistentNaming
        public class ModifyTest_NoCtt_Softing_DemoServer_Http : ModifyTest_NoCtt
        // ReSharper restore InconsistentNaming
        {
            public ModifyTest_NoCtt_Softing_DemoServer_Http()
            {
                EndpointDescriptorDirect = LegacyUATestEnvironment.Softing_OpcUaNetDemoServer.EndpointDescriptors.Http;
            }

            [ClassInitialize]
            static public void SocketPrecheck(TestContext context)
            {
                LegacyUATestEnvironment.Current.PrecheckEndpoint(LegacyUATestEnvironment.Softing_OpcUaNetDemoServer.EndpointDescriptors.Http);
            }
        }



        #region Test Methods
        // ReSharper disable InconsistentNaming

        [TestCategory("Keyword:DeleteSubscription")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_012_01_Inverted()
        {
            TestCase_Err_Subscription(
                true,
                @"Subscription Services\Subscription Client Modify\Test Cases\Err-012-01.js",
                UAEngineEventIds.SubscriptionRemoveFailure,
                LogEntryType.Warning,
                new UAStatusCode(UACodeBits.BadNothingToDo, 0));
        }

        [TestCategory("Keyword:DeleteSubscription")]
        [TestCategory("Live")]
        [TestCategory("OpcCompliance")]
        [TestMethod]
        public void TestCase_Err_012_02_Inverted()
        {
            TestCase_Err_Subscription(
                true,
                @"Subscription Services\Subscription Client Modify\Test Cases\Err-012-02.js",
                UAEngineEventIds.SubscriptionRemoveFailure,
                LogEntryType.Warning,
                new UAStatusCode(UACodeBits.BadTooManyOperations, 0));
        }

        // ReSharper restore InconsistentNaming
        #endregion



        #region Private Methods

        #endregion
    }
}
