﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.DataAccess.AddressSpace;
using OpcLabs.EasyOpcFactory.DataAccess.AddressSpace;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.DataAccess.AddressSpace
{
    public partial class DANodeElementCollectionTest
    {
        [TestCategory("BinarySerialization")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        [NotNull]
        static private DANodeElementCollection CreateSerializationTarget0()
        {
            return new DANodeElementCollection();
        }

        [NotNull]
        static private DANodeElementCollection CreateSerializationTarget1()
        {
            var nodeElementCollection = new DANodeElementCollection
                                            {
                                                DANodeElementInstances.Instance0,
                                                DANodeElementInstances.Instance1,
                                                DANodeElementInstances.Instance2,
                                            };
            return nodeElementCollection;
        }
    }
}
