﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.ComInterop;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.DataAccess.Extensions;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.DataAccess
{
    public class DAItemPropertyRecordTest
    {
        [TestCategory("BinarySerialization")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestMethod]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        [NotNull]
        public DAItemPropertyRecord CreateSerializationTarget0()
        {
            return new DAItemPropertyRecord();
        }

        [NotNull]
        public DAItemPropertyRecord CreateSerializationTarget1()
        {
            var itemPropertyRecord = new DAItemPropertyRecord
            {
                AccessRights = new DAAccessRight(true, true),
                //AlarmAreaList = new[] {"TestAlarmArea1", "TestAlarmArea2"},
                AlarmQuickHelp = "TestAlarmQuickHelp",
                ChangeRateLimit = -0.123456789,
                DataType = VarTypes.R4,
                EUType = 1,
                Quality = DAQualities.CommFailure,
                Value = "TestValue"
            };
            return itemPropertyRecord;
        }
    }
}
