﻿
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Extensions;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.DataAccess.Engine;
using OpcLabs.EasyOpc.UA;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.DataAccess
{
    public partial class EasyDAClientTest
    {
        #region Static Private Methods

        [NotNull]
        static private EasyDAClient CreateSerializationTarget0()
        {
            return new EasyDAClient();
        }

        [NotNull]
        static private EasyDAClient CreateSerializationTarget1()
        {
            var client = new EasyDAClient
            {
                InstanceParameters =
                {
                    Mode = { DesiredMethod = DAReadWriteMethod.Synchronous },
                    HoldPeriods = { TopicWrite = 2222 },
                    Timeouts = { BrowseAccessPaths = 3333 },
                    UpdateRates = { ReadAutomatic = 4444 }
                }
            };
            return client;
        }

        #endregion



        [TestCategory("BinarySerialization")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }
    }
}
