﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA.Engine;
using OpcLabs.EasyOpcFactory.UA.Engine;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.UA.Engine
{
    public partial class UAClientAdaptableParametersTest
    {
        [TestCategory("OpcUA")]
        [TestMethod]
        // ReSharper disable InconsistentNaming
        public void CopyEquivalence_Default()
        // ReSharper restore InconsistentNaming
        {
            UAClientAdaptableParameters target = UAClientAdaptableParameters.Default;
            AssertUtilities.WriteLine(target);
            var copy = new UAClientAdaptableParameters(target);
            AssertUtilities.WriteLine(copy);
            Assert.IsTrue(copy.Equals(target));
        }

        [TestCategory("OpcUA")]
        [TestMethod]
        // ReSharper disable InconsistentNaming
        public void CopyEquivalence_Instance1()
        // ReSharper restore InconsistentNaming
        {
            UAClientAdaptableParameters target = UAClientAdaptableParametersInstances.Instance1;
            AssertUtilities.WriteLine(target);
            var copy = new UAClientAdaptableParameters(target);
            AssertUtilities.WriteLine(copy);
            Assert.IsTrue(copy.Equals(target));
        }

        [TestCategory("OpcUA")]
        [TestMethod]
        // ReSharper disable InconsistentNaming
        public void CopyEquivalence_WithUserIdentity()
        // ReSharper restore InconsistentNaming
        {
            UAClientAdaptableParameters target = UAClientAdaptableParametersInstances.Instance1;
            target.SessionParameters.UserIdentity.UserNameTokenInfo.UserName = "usr";
            target.SessionParameters.UserIdentity.UserNameTokenInfo.Password = "pwd";
            AssertUtilities.WriteLine(target);
            var copy = new UAClientAdaptableParameters(target);
            AssertUtilities.WriteLine(copy);
            Assert.IsTrue(copy.Equals(target));
        }
    }
}
