﻿using System.Diagnostics;
using System.IO;
using System.Reflection;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Collections.Specialized;
using OpcLabs.BaseLib.OperationModel.Generic;
using OpcLabs.EasyOpc.UA.PubSub.InformationModel;
using OpcLabs.EasyOpc.UA.PubSub.InformationModel.Extensions;
using OpcLabs.EasyOpc.UA.PubSub.InformationModel.Implementation;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.UA.PubSub.InformationModel
{
    [TestClass]
    public class UAReadOnlyPubSubMemoryConfigurationTest
    {
        [TestMethod]
        public void LoadFromUABinaryStreamTest()
        {
            TestSection.Arrange();
            Stream stream = Assembly.GetExecutingAssembly().GetManifestResourceStream(
                "OpcLabs.EasyOpcTest.UA.PubSub.InformationModel.pubsubconfig.bin");
            Debug.Assert(stream != null);

            TestSection.Act();
            ValueResult<UAPubSubMemoryConfiguration> pubSubMemoryConfigurationResult = 
                UAReadOnlyPubSubMemoryConfiguration.UABinaryLoader.FromStream(stream);

            TestSection.Assert();
            Assert.IsTrue(pubSubMemoryConfigurationResult.Succeeded);
            UAPubSubMemoryConfiguration pubSubMemoryConfiguration = pubSubMemoryConfigurationResult.Value;
            Assert.IsNotNull(pubSubMemoryConfiguration);
            StringCollection allPublishedDataSetNames = pubSubMemoryConfiguration.GetAllPublishedDataSetNames();
            Assert.IsNotNull(allPublishedDataSetNames);
            Assert.AreEqual(3, allPublishedDataSetNames.Count);
            StringCollection dataSetFolderNames = pubSubMemoryConfiguration.GetDataSetFolderNames(new string[0]);
            Assert.IsNotNull(dataSetFolderNames);
            Assert.AreEqual(0, dataSetFolderNames.Count);
            StringCollection pubSubConnectionNames = pubSubMemoryConfiguration.GetPubSubConnectionNames();
            Assert.IsNotNull(pubSubConnectionNames);
            Assert.AreEqual(1, pubSubConnectionNames.Count);
            // IMPROVE: assert more
        }
    }
}
