﻿
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc;
using OpcLabs.EasyOpcFactory;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest
{
    public partial class ServerElementCollectionTest
    {
        [TestCategory("BinarySerialization")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("BinarySerialization")]
        [TestMethod]
        public void BinarySerializationTest2()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget2());
        }

        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest2()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget2());
        }

        [NotNull]
        private ServerElementCollection CreateSerializationTarget0()
        {
            return new ServerElementCollection();
        }

        [NotNull]
        private ServerElementCollection CreateSerializationTarget1()
        {
            var serverElementCollection = new ServerElementCollection
                                              {
                                                  ServerElementInstances.Instance1,
                                                  ServerElementInstances.Instance2,
                                              };
            return serverElementCollection;
        }

        [NotNull]
        private ServerElementCollection CreateSerializationTarget2()
        {
            var serverElementCollection = new ServerElementCollection
                                              {
                                                  ServerElementInstances.Instance1,
                                                  ServerElementInstances.Instance2,
                                                  ServerElementInstances.Instance3,
                                              };
            return serverElementCollection;
        }
    }
}
