﻿
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Collections.ObjectModel.Extensions;
using OpcLabs.UnitTestLib;
using System.Diagnostics;

// Assemblies:
//   OpcLabs.EasyOpcUA, Version=5.55.0.14, Culture=neutral, PublicKeyToken=6faddca41dacb409

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AddressSpace.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAEncodingNameConverterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAEncodingNameConverterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AddressSpace.Implementation.UAEncodingNameConverter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AddressSpace.Implementation.UAEncodingNameConverter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AddressSpace.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAGuidIdentifierConverterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAGuidIdentifierConverterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AddressSpace.Implementation.UAGuidIdentifierConverter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AddressSpace.Implementation.UAGuidIdentifierConverter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AddressSpace.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAIdentifierConverterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAIdentifierConverterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AddressSpace.Implementation.UAIdentifierConverter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AddressSpace.Implementation.UAIdentifierConverter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AddressSpace.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANodeIdConverterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANodeIdConverterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AddressSpace.Implementation.UANodeIdConverter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AddressSpace.Implementation.UANodeIdConverter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AddressSpace.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANumericIdentifierConverterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANumericIdentifierConverterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AddressSpace.Implementation.UANumericIdentifierConverter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AddressSpace.Implementation.UANumericIdentifierConverter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AddressSpace.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAOpaqueIdentifierConverterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAOpaqueIdentifierConverterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AddressSpace.Implementation.UAOpaqueIdentifierConverter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AddressSpace.Implementation.UAOpaqueIdentifierConverter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AddressSpace.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAQualifiedNameConverterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAQualifiedNameConverterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AddressSpace.Implementation.UAQualifiedNameConverter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AddressSpace.Implementation.UAQualifiedNameConverter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AddressSpace.Parsing
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANodeIdFormatExceptionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANodeIdFormatExceptionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AddressSpace.Parsing.UANodeIdFormatException));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AddressSpace.Parsing.UANodeIdFormatException...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AddressSpace.Parsing
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANodeIdParserTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANodeIdParserTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AddressSpace.Parsing.UANodeIdParser));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AddressSpace.Parsing.UANodeIdParser...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AddressSpace.Parsing
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAQualifiedNameFormatExceptionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAQualifiedNameFormatExceptionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AddressSpace.Parsing.UAQualifiedNameFormatException));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AddressSpace.Parsing.UAQualifiedNameFormatException...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AddressSpace.Parsing
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAQualifiedNameParserTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAQualifiedNameParserTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AddressSpace.Parsing.UAQualifiedNameParser));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AddressSpace.Parsing.UAQualifiedNameParser...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AddressSpace
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANodeElementTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANodeElementTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AddressSpace.UANodeElement));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AddressSpace.UANodeElement...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AddressSpace
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANodeElementCollectionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANodeElementCollectionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AddressSpace.UANodeElementCollection));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AddressSpace.UANodeElementCollection...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AddressSpace
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANodeIdTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANodeIdTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AddressSpace.UANodeId));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AddressSpace.UANodeId...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AddressSpace
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANodeIdCollectionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANodeIdCollectionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AddressSpace.UANodeIdCollection));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AddressSpace.UANodeIdCollection...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AddressSpace
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANodeIdSetTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANodeIdSetTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AddressSpace.UANodeIdSet));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AddressSpace.UANodeIdSet...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AddressSpace
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAQualifiedNameTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAQualifiedNameTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AddressSpace.UAQualifiedName));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AddressSpace.UAQualifiedName...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AddressSpace
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAQualifiedNameCollectionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAQualifiedNameCollectionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AddressSpace.UAQualifiedNameCollection));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AddressSpace.UAQualifiedNameCollection...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AddressSpace
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAQualifiedNameSetTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAQualifiedNameSetTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AddressSpace.UAQualifiedNameSet));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AddressSpace.UAQualifiedNameSet...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AlarmsAndConditions
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAAlarmsAndConditionsClientTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAAlarmsAndConditionsClientTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AlarmsAndConditions.EasyUAAlarmsAndConditionsClient));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AlarmsAndConditions.EasyUAAlarmsAndConditionsClient...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.AlarmsAndConditions
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UABaseEventObjectTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UABaseEventObjectTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.AlarmsAndConditions.UABaseEventObject));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.AlarmsAndConditions.UABaseEventObject...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Application
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAObtainNewCertificateParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAObtainNewCertificateParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Application.UAObtainNewCertificateParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Application.UAObtainNewCertificateParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Browsing.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAEndpointBrowseNodeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAEndpointBrowseNodeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Browsing.Internal.UAEndpointBrowseNode));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Browsing.Internal.UAEndpointBrowseNode...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Browsing.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAHostBrowseNodeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAHostBrowseNodeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Browsing.Internal.UAHostBrowseNode));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Browsing.Internal.UAHostBrowseNode...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Browsing.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAIndexRangeListBrowseableTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAIndexRangeListBrowseableTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Browsing.Internal.UAIndexRangeListBrowseable));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Browsing.Internal.UAIndexRangeListBrowseable...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Browsing.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UALocalApplicationBrowseNodeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UALocalApplicationBrowseNodeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Browsing.Internal.UALocalApplicationBrowseNode));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Browsing.Internal.UALocalApplicationBrowseNode...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Browsing.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANetworkBrowseNodeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANetworkBrowseNodeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Browsing.Internal.UANetworkBrowseNode));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Browsing.Internal.UANetworkBrowseNode...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Browsing.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANetworkBrowseableTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANetworkBrowseableTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Browsing.Internal.UANetworkBrowseable));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Browsing.Internal.UANetworkBrowseable...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Browsing.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANetworkOrGlobalApplicationBrowseNodeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANetworkOrGlobalApplicationBrowseNodeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Browsing.Internal.UANetworkOrGlobalApplicationBrowseNode));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Browsing.Internal.UANetworkOrGlobalApplicationBrowseNode...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Browsing.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANodeBrowseNodeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANodeBrowseNodeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Browsing.Internal.UANodeBrowseNode));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Browsing.Internal.UANodeBrowseNode...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Browsing
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANodeBrowseFilterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANodeBrowseFilterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Browsing.UANodeBrowseFilter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Browsing.UANodeBrowseFilter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Connectivity
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAAttributePointTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAAttributePointTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Connectivity.UAAttributePoint));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Connectivity.UAAttributePoint...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Connectivity
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAAttributePointReadArgumentsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAAttributePointReadArgumentsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Connectivity.UAAttributePointReadArguments));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Connectivity.UAAttributePointReadArguments...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Connectivity
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAAttributePointReadParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAAttributePointReadParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Connectivity.UAAttributePointReadParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Connectivity.UAAttributePointReadParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Connectivity
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAAttributePointSubscribeArgumentsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAAttributePointSubscribeArgumentsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Connectivity.UAAttributePointSubscribeArguments));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Connectivity.UAAttributePointSubscribeArguments...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Connectivity
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAAttributePointSubscribeParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAAttributePointSubscribeParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Connectivity.UAAttributePointSubscribeParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Connectivity.UAAttributePointSubscribeParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Connectivity
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAAttributePointWriteArgumentsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAAttributePointWriteArgumentsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Connectivity.UAAttributePointWriteArguments));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Connectivity.UAAttributePointWriteArguments...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Connectivity
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAAttributePointWriteParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAAttributePointWriteParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Connectivity.UAAttributePointWriteParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Connectivity.UAAttributePointWriteParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Connectivity
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAConnectivityTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAConnectivityTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Connectivity.UAConnectivity));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Connectivity.UAConnectivity...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Connectivity
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAConnectivityConfigurationTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAConnectivityConfigurationTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Connectivity.UAConnectivityConfiguration));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Connectivity.UAConnectivityConfiguration...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.DataAccess
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAEUInformationTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAEUInformationTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.DataAccess.UAEUInformation));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.DataAccess.UAEUInformation...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.DataAccess
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UARangeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UARangeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.DataAccess.UARange));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.DataAccess.UARange...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.DataAccess
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UATwoStateDiscreteNodeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UATwoStateDiscreteNodeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.DataAccess.UATwoStateDiscreteNode));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.DataAccess.UATwoStateDiscreteNode...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.DataTypeModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataTypeDescriptorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataTypeDescriptorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.DataTypeModel.UADataTypeDescriptor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.DataTypeModel.UADataTypeDescriptor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.DataTypeModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataTypeSystemParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataTypeSystemParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.DataTypeModel.UADataTypeSystemParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.DataTypeModel.UADataTypeSystemParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.DataTypeModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAOpcBinaryDtsParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAOpcBinaryDtsParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.DataTypeModel.UAOpcBinaryDtsParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.DataTypeModel.UAOpcBinaryDtsParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.DataTypeModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAServerDtmpParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAServerDtmpParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.DataTypeModel.UAServerDtmpParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.DataTypeModel.UAServerDtmpParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.DataTypeModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAXmlSchemaDtsParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAXmlSchemaDtsParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.DataTypeModel.UAXmlSchemaDtsParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.DataTypeModel.UAXmlSchemaDtsParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Diagnostics
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAClientEventSourceTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAClientEventSourceTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Diagnostics.EasyUAClientEventSource));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Diagnostics.EasyUAClientEventSource...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Discovery
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAApplicationDescriptionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAApplicationDescriptionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Discovery.UAApplicationDescription));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Discovery.UAApplicationDescription...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Discovery
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAApplicationElementTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAApplicationElementTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Discovery.UAApplicationElement));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Discovery.UAApplicationElement...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Discovery
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADiscoveryElementTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADiscoveryElementTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Discovery.UADiscoveryElement));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Discovery.UADiscoveryElement...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Discovery
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADiscoveryElementCollectionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADiscoveryElementCollectionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Discovery.UADiscoveryElementCollection));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Discovery.UADiscoveryElementCollection...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Discovery
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAGlobalApplicationDiscoveryQueryTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAGlobalApplicationDiscoveryQueryTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Discovery.UAGlobalApplicationDiscoveryQuery));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Discovery.UAGlobalApplicationDiscoveryQuery...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Discovery
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UALocalApplicationDiscoveryQueryTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UALocalApplicationDiscoveryQueryTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Discovery.UALocalApplicationDiscoveryQuery));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Discovery.UALocalApplicationDiscoveryQuery...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Discovery
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UALocalEndpointDiscoveryQueryTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UALocalEndpointDiscoveryQueryTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Discovery.UALocalEndpointDiscoveryQuery));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Discovery.UALocalEndpointDiscoveryQuery...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Discovery
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANetworkServerDiscoveryQueryTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANetworkServerDiscoveryQueryTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Discovery.UANetworkServerDiscoveryQuery));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Discovery.UANetworkServerDiscoveryQuery...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Discovery
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAQueryApplicationsFilterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAQueryApplicationsFilterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Discovery.UAQueryApplicationsFilter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Discovery.UAQueryApplicationsFilter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Discovery
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAServerOnNetworkTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAServerOnNetworkTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Discovery.UAServerOnNetwork));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Discovery.UAServerOnNetwork...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAClientTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAClientTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.EasyUAClient));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.EasyUAClient...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAClientConfigurationTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAClientConfigurationTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.EasyUAClientConfiguration));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.EasyUAClientConfiguration...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAClientSelectorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAClientSelectorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.EasyUAClientSelector));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.EasyUAClientSelector...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAEngineExceptionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAEngineExceptionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.EasyUAEngineException));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.EasyUAEngineException...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUASpecializedClientTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUASpecializedClientTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.EasyUASpecializedClient));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.EasyUASpecializedClient...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAAdaptableParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAAdaptableParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.EasyUAAdaptableParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.EasyUAAdaptableParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAClientModeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAClientModeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.EasyUAClientMode));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.EasyUAClientMode...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAEngineParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAEngineParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.EasyUAEngineParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.EasyUAEngineParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAInstanceParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAInstanceParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.EasyUAInstanceParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.EasyUAInstanceParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUASharedParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUASharedParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.EasyUASharedParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.EasyUASharedParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UACertificateAcceptancePolicyTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UACertificateAcceptancePolicyTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.UACertificateAcceptancePolicy));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.UACertificateAcceptancePolicy...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAClientAdaptableParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAClientAdaptableParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.UAClientAdaptableParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.UAClientAdaptableParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAClientApplicationParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAClientApplicationParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.UAClientApplicationParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.UAClientApplicationParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAClientEngineExceptionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAClientEngineExceptionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.UAClientEngineException));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.UAClientEngineException...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAClientEngineParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAClientEngineParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.UAClientEngineParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.UAClientEngineParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAClientMonitoredItemParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAClientMonitoredItemParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.UAClientMonitoredItemParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.UAClientMonitoredItemParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAClientSessionParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAClientSessionParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.UAClientSessionParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.UAClientSessionParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAClientSubscriptionParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAClientSubscriptionParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.UAClientSubscriptionParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.UAClientSubscriptionParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADiscoveryParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADiscoveryParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.UADiscoveryParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.UADiscoveryParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAEndpointDescriptionChecksTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAEndpointDescriptionChecksTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.UAEndpointDescriptionChecks));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.UAEndpointDescriptionChecks...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAEndpointSelectionPolicyTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAEndpointSelectionPolicyTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.UAEndpointSelectionPolicy));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.UAEndpointSelectionPolicy...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAEnhancedSessionParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAEnhancedSessionParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.UAEnhancedSessionParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.UAEnhancedSessionParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAHostParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAHostParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.UAHostParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.UAHostParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UASmartEngineParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UASmartEngineParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.UASmartEngineParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.UASmartEngineParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UASmartSessionParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UASmartSessionParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.UASmartSessionParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.UASmartSessionParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAUserInteractionParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAUserInteractionParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Engine.UAUserInteractionParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Engine.UAUserInteractionParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Filtering
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAAttributeOperandTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAAttributeOperandTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Filtering.UAAttributeOperand));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Filtering.UAAttributeOperand...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Filtering
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAContentFilterElementTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAContentFilterElementTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Filtering.UAContentFilterElement));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Filtering.UAContentFilterElement...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Filtering
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAContentFilterElementBuilderTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAContentFilterElementBuilderTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Filtering.UAContentFilterElementBuilder));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Filtering.UAContentFilterElementBuilder...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Filtering
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAFilterOperandTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAFilterOperandTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Filtering.UAFilterOperand));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Filtering.UAFilterOperand...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Filtering
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAFilterOperandCollectionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAFilterOperandCollectionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Filtering.UAFilterOperandCollection));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Filtering.UAFilterOperandCollection...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Filtering
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UALiteralOperandTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UALiteralOperandTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Filtering.UALiteralOperand));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Filtering.UALiteralOperand...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Filtering
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UASimpleAttributeOperandTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UASimpleAttributeOperandTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Filtering.UASimpleAttributeOperand));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Filtering.UASimpleAttributeOperand...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Filtering
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UASimpleAttributeOperandCollectionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UASimpleAttributeOperandCollectionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Filtering.UASimpleAttributeOperandCollection));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Filtering.UASimpleAttributeOperandCollection...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Formatting
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataValueFormatterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataValueFormatterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Formatting.UADataValueFormatter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Formatting.UADataValueFormatter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Formatting
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAStatusCodeFormatterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAStatusCodeFormatterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Formatting.UAStatusCodeFormatter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Formatting.UAStatusCodeFormatter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Gds
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUACertificateManagementClientTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUACertificateManagementClientTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Gds.EasyUACertificateManagementClient));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Gds.EasyUACertificateManagementClient...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Gds
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAGlobalDiscoveryClientTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAGlobalDiscoveryClientTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Gds.EasyUAGlobalDiscoveryClient));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Gds.EasyUAGlobalDiscoveryClient...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Gds.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UATrustListDataTypeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UATrustListDataTypeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Gds.Internal.UATrustListDataType));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Gds.Internal.UATrustListDataType...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Gds
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAApplicationRecordDataTypeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAApplicationRecordDataTypeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Gds.UAApplicationRecordDataType));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Gds.UAApplicationRecordDataType...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Graphs
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UATreePositionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UATreePositionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Graphs.UATreePosition));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Graphs.UATreePosition...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAClientEnqueuingCompositorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAClientEnqueuingCompositorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Implementation.EasyUAClientEnqueuingCompositor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Implementation.EasyUAClientEnqueuingCompositor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EnqueuingEasyUAClientTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EnqueuingEasyUAClientTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Implementation.EnqueuingEasyUAClient));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Implementation.EnqueuingEasyUAClient...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Implementation.NetSdk.ClientServer
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAClientEngineTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAClientEngineTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Implementation.NetSdk.ClientServer.EasyUAClientEngine));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Implementation.NetSdk.ClientServer.EasyUAClientEngine...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Implementation.NetSdk.ClientServer
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAClientEngineBaseTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAClientEngineBaseTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Implementation.NetSdk.ClientServer.EasyUAClientEngineBase));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Implementation.NetSdk.ClientServer.EasyUAClientEngineBase...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Implementation.NetSdk.ClientServer
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class NetSdkEasyUAClientTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public NetSdkEasyUAClientTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Implementation.NetSdk.ClientServer.NetSdkEasyUAClient));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Implementation.NetSdk.ClientServer.NetSdkEasyUAClient...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Implementation.NetSdk.PubSub
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAPubSubEngineTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAPubSubEngineTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Implementation.NetSdk.PubSub.EasyUAPubSubEngine));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Implementation.NetSdk.PubSub.EasyUAPubSubEngine...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Implementation.NetSdk.PubSub
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class NetSdkEasyUASubscriberTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public NetSdkEasyUASubscriberTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Implementation.NetSdk.PubSub.NetSdkEasyUASubscriber));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Implementation.NetSdk.PubSub.NetSdkEasyUASubscriber...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAEndpointDescriptorConverterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAEndpointDescriptorConverterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Implementation.UAEndpointDescriptorConverter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Implementation.UAEndpointDescriptorConverter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAIndexRangeListConverterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAIndexRangeListConverterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Implementation.UAIndexRangeListConverter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Implementation.UAIndexRangeListConverter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANodeDescriptorConverterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANodeDescriptorConverterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Implementation.UANodeDescriptorConverter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Implementation.UANodeDescriptorConverter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UnsupportedEasyUAClientTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UnsupportedEasyUAClientTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Implementation.UnsupportedEasyUAClient));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Implementation.UnsupportedEasyUAClient...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.InformationModel.FileTransfer
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAFileTransferClientTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAFileTransferClientTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.FileTransfer.EasyUAFileTransferClient));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.InformationModel.FileTransfer.EasyUAFileTransferClient...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.InformationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAEmptyModelProviderTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAEmptyModelProviderTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.InformationModel.UAEmptyModelProvider));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.InformationModel.UAEmptyModelProvider...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.InformationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAModelAccessFailureEventArgsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAModelAccessFailureEventArgsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.InformationModel.UAModelAccessFailureEventArgs));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.InformationModel.UAModelAccessFailureEventArgs...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.InformationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAModelClientTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAModelClientTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.InformationModel.UAModelClient));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.InformationModel.UAModelClient...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.InformationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAModelClientExceptionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAModelClientExceptionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.InformationModel.UAModelClientException));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.InformationModel.UAModelClientException...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.InformationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAModelNodeDescriptorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAModelNodeDescriptorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.InformationModel.UAModelNodeDescriptor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.InformationModel.UAModelNodeDescriptor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.InformationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAModellingExceptionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAModellingExceptionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.InformationModel.UAModellingException));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.InformationModel.UAModellingException...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.InformationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAResolveNodeParametersEventArgsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAResolveNodeParametersEventArgsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.InformationModel.UAResolveNodeParametersEventArgs));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.InformationModel.UAResolveNodeParametersEventArgs...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.InformationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAServerModelProviderTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAServerModelProviderTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.InformationModel.UAServerModelProvider));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.InformationModel.UAServerModelProvider...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAClientPoolTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAClientPoolTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Internal.EasyUAClientPool));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Internal.EasyUAClientPool...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class SimulatedEasyUAClientTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public SimulatedEasyUAClientTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Internal.SimulatedEasyUAClient));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Internal.SimulatedEasyUAClient...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.LiveMapping
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAClientDataMappingTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAClientDataMappingTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.LiveMapping.UAClientDataMapping));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.LiveMapping.UAClientDataMapping...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.LiveMapping
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAClientDataMappingSourceTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAClientDataMappingSourceTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.LiveMapping.UAClientDataMappingSource));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.LiveMapping.UAClientDataMappingSource...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.LiveMapping
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAClientMapperTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAClientMapperTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.LiveMapping.UAClientMapper));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.LiveMapping.UAClientMapper...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.LiveMapping
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataAttributeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataAttributeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.LiveMapping.UADataAttribute));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.LiveMapping.UADataAttribute...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.LiveMapping
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataChangeFilterAttributeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataChangeFilterAttributeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.LiveMapping.UADataChangeFilterAttribute));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.LiveMapping.UADataChangeFilterAttribute...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.LiveMapping
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAEndpointAttributeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAEndpointAttributeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.LiveMapping.UAEndpointAttribute));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.LiveMapping.UAEndpointAttribute...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.LiveMapping
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAMappedNodeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAMappedNodeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.LiveMapping.UAMappedNode));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.LiveMapping.UAMappedNode...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.LiveMapping
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAMappingContextTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAMappingContextTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.LiveMapping.UAMappingContext));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.LiveMapping.UAMappingContext...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.LiveMapping
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAMappingProviderTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAMappingProviderTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.LiveMapping.UAMappingProvider));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.LiveMapping.UAMappingProvider...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.LiveMapping
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAMemberAttributeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAMemberAttributeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.LiveMapping.UAMemberAttribute));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.LiveMapping.UAMemberAttribute...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.LiveMapping
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAMonitoringAttributeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAMonitoringAttributeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.LiveMapping.UAMonitoringAttribute));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.LiveMapping.UAMonitoringAttribute...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.LiveMapping
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANodeAttributeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANodeAttributeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.LiveMapping.UANodeAttribute));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.LiveMapping.UANodeAttribute...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.LiveMapping
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAReadAttributeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAReadAttributeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.LiveMapping.UAReadAttribute));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.LiveMapping.UAReadAttribute...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.LiveMapping
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UASubscriptionAttributeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UASubscriptionAttributeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.LiveMapping.UASubscriptionAttribute));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.LiveMapping.UASubscriptionAttribute...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.LiveMapping
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UATypeAttributeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UATypeAttributeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.LiveMapping.UATypeAttribute));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.LiveMapping.UATypeAttribute...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.LiveMapping
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UATypeMappingDefinitionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UATypeMappingDefinitionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.LiveMapping.UATypeMappingDefinition));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.LiveMapping.UATypeMappingDefinition...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Navigation.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UABrowsePathConverterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UABrowsePathConverterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Navigation.Implementation.UABrowsePathConverter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Navigation.Implementation.UABrowsePathConverter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Navigation.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UABrowsePathElementConverterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UABrowsePathElementConverterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Navigation.Implementation.UABrowsePathElementConverter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Navigation.Implementation.UABrowsePathElementConverter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Navigation.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAAddressSpaceNodeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAAddressSpaceNodeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Navigation.Internal.UAAddressSpaceNode));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Navigation.Internal.UAAddressSpaceNode...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Navigation.Parsing
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UABrowsePathFormatExceptionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UABrowsePathFormatExceptionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Navigation.Parsing.UABrowsePathFormatException));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Navigation.Parsing.UABrowsePathFormatException...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Navigation.Parsing
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UABrowsePathParserTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UABrowsePathParserTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Navigation.Parsing.UABrowsePathParser));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Navigation.Parsing.UABrowsePathParser...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Navigation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UABrowsePathTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UABrowsePathTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Navigation.UABrowsePath));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Navigation.UABrowsePath...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Navigation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UABrowsePathElementTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UABrowsePathElementTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Navigation.UABrowsePathElement));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Navigation.UABrowsePathElement...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Navigation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UABrowsePathElementCollectionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UABrowsePathElementCollectionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Navigation.UABrowsePathElementCollection));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Navigation.UABrowsePathElementCollection...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUADataChangeNotificationEventArgsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUADataChangeNotificationEventArgsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.EasyUADataChangeNotificationEventArgs));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.EasyUADataChangeNotificationEventArgs...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAEngineConditionChangedEventArgsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAEngineConditionChangedEventArgsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.EasyUAEngineConditionChangedEventArgs));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.EasyUAEngineConditionChangedEventArgs...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAEventNotificationEventArgsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAEventNotificationEventArgsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.EasyUAEventNotificationEventArgs));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.EasyUAEventNotificationEventArgs...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAMonitoredItemArgumentsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAMonitoredItemArgumentsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.EasyUAMonitoredItemArguments));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.EasyUAMonitoredItemArguments...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAMonitoredItemArgumentsDictionaryTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAMonitoredItemArgumentsDictionaryTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.EasyUAMonitoredItemArgumentsDictionary));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.EasyUAMonitoredItemArgumentsDictionary...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAServerConditionChangedEventArgsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAServerConditionChangedEventArgsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.EasyUAServerConditionChangedEventArgs));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.EasyUAServerConditionChangedEventArgs...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUASubscriptionChangeArgumentsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUASubscriptionChangeArgumentsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.EasyUASubscriptionChangeArguments));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.EasyUASubscriptionChangeArguments...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel.Formatting
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAAttributeDataResultFormatterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAAttributeDataResultFormatterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.Formatting.UAAttributeDataResultFormatter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.Formatting.UAAttributeDataResultFormatter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UALogicalExceptionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UALogicalExceptionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.Implementation.UALogicalException));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.Implementation.UALogicalException...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAMonitoredItemArgumentsConverterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAMonitoredItemArgumentsConverterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.Implementation.UAMonitoredItemArgumentsConverter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.Implementation.UAMonitoredItemArgumentsConverter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAAttributeArgumentsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAAttributeArgumentsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.UAAttributeArguments));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.UAAttributeArguments...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAAttributeDataResultTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAAttributeDataResultTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.UAAttributeDataResult));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.UAAttributeDataResult...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UABrowseArgumentsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UABrowseArgumentsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.UABrowseArguments));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.UABrowseArguments...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UACallArgumentsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UACallArgumentsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.UACallArguments));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.UACallArguments...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAExceptionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAExceptionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.UAException));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.UAException...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAMonitoredItemArgumentsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAMonitoredItemArgumentsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.UAMonitoredItemArguments));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.UAMonitoredItemArguments...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAMonitoredItemArgumentsCollectionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAMonitoredItemArgumentsCollectionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.UAMonitoredItemArgumentsCollection));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.UAMonitoredItemArgumentsCollection...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANodeArgumentsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANodeArgumentsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.UANodeArguments));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.UANodeArguments...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANodeElementCollectionResultTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANodeElementCollectionResultTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.UANodeElementCollectionResult));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.UANodeElementCollectionResult...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAReadArgumentsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAReadArgumentsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.UAReadArguments));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.UAReadArguments...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAWriteArgumentsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAWriteArgumentsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.UAWriteArguments));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.UAWriteArguments...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAWriteResultTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAWriteResultTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.UAWriteResult));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.UAWriteResult...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAWriteValueArgumentsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAWriteValueArgumentsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.OperationModel.UAWriteValueArguments));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.OperationModel.UAWriteValueArguments...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Parsing
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAIndexRangeListFormatExceptionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAIndexRangeListFormatExceptionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Parsing.UAIndexRangeListFormatException));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Parsing.UAIndexRangeListFormatException...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Parsing
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAIndexRangeListParserTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAIndexRangeListParserTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Parsing.UAIndexRangeListParser));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Parsing.UAIndexRangeListParser...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Plugins.ComplexData.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAComplexDataPluginTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAComplexDataPluginTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Plugins.ComplexData.Implementation.UAComplexDataPlugin));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Plugins.ComplexData.Implementation.UAComplexDataPlugin...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Plugins.ComplexData
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAComplexDataParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAComplexDataParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Plugins.ComplexData.UAComplexDataParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Plugins.ComplexData.UAComplexDataParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Plugins.ComplexData
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAComplexDataPluginParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAComplexDataPluginParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Plugins.ComplexData.UAComplexDataPluginParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Plugins.ComplexData.UAComplexDataPluginParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Plugins.ComplexData
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAGenericObjectTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAGenericObjectTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Plugins.ComplexData.UAGenericObject));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Plugins.ComplexData.UAGenericObject...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Plugins.ConsoleInteraction
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAConsoleInteractionPluginParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAConsoleInteractionPluginParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Plugins.ConsoleInteraction.UAConsoleInteractionPluginParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Plugins.ConsoleInteraction.UAConsoleInteractionPluginParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Plugins.OpcBinaryDts.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAOpcBinaryDtsPluginTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAOpcBinaryDtsPluginTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Plugins.OpcBinaryDts.Implementation.UAOpcBinaryDtsPlugin));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Plugins.OpcBinaryDts.Implementation.UAOpcBinaryDtsPlugin...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Plugins.ServerDtmp.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAServerDtmpPluginTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAServerDtmpPluginTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Plugins.ServerDtmp.Implementation.UAServerDtmpPlugin));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Plugins.ServerDtmp.Implementation.UAServerDtmpPlugin...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Plugins.ServerDtmp
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAServerDtmpPluginParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAServerDtmpPluginParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Plugins.ServerDtmp.UAServerDtmpPluginParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Plugins.ServerDtmp.UAServerDtmpPluginParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Plugins.WindowsFormsInteraction
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAWindowsFormsInteractionPluginParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAWindowsFormsInteractionPluginParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Plugins.WindowsFormsInteraction.UAWindowsFormsInteractionPluginParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Plugins.WindowsFormsInteraction.UAWindowsFormsInteractionPluginParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Plugins.XmlSchemaDts.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAXmlSchemaDtsPluginTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAXmlSchemaDtsPluginTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Plugins.XmlSchemaDts.Implementation.UAXmlSchemaDtsPlugin));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Plugins.XmlSchemaDts.Implementation.UAXmlSchemaDtsPlugin...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UABrokerConnectionTransportParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UABrokerConnectionTransportParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UABrokerConnectionTransportParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UABrokerConnectionTransportParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UABrokerDataSetReaderTransportParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UABrokerDataSetReaderTransportParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UABrokerDataSetReaderTransportParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UABrokerDataSetReaderTransportParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UABrokerDataSetWriterTransportParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UABrokerDataSetWriterTransportParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UABrokerDataSetWriterTransportParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UABrokerDataSetWriterTransportParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UABrokerWriterGroupTransportParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UABrokerWriterGroupTransportParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UABrokerWriterGroupTransportParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UABrokerWriterGroupTransportParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAConfigurationVersionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAConfigurationVersionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAConfigurationVersion));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAConfigurationVersion...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataSetFolderDataTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataSetFolderDataTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UADataSetFolderData));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UADataSetFolderData...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataSetMetaDataTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataSetMetaDataTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UADataSetMetaData));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UADataSetMetaData...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataSetReaderElementTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataSetReaderElementTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UADataSetReaderElement));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UADataSetReaderElement...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataSetReaderMessageParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataSetReaderMessageParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UADataSetReaderMessageParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UADataSetReaderMessageParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataSetReaderTransportParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataSetReaderTransportParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UADataSetReaderTransportParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UADataSetReaderTransportParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataSetWriterDataTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataSetWriterDataTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UADataSetWriterData));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UADataSetWriterData...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataSetWriterElementTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataSetWriterElementTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UADataSetWriterElement));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UADataSetWriterElement...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataSetWriterMessageParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataSetWriterMessageParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UADataSetWriterMessageParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UADataSetWriterMessageParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataSetWriterTransportParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataSetWriterTransportParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UADataSetWriterTransportParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UADataSetWriterTransportParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADatagramConnectionTransportParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADatagramConnectionTransportParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UADatagramConnectionTransportParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UADatagramConnectionTransportParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADatagramWriterGroupTransportParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADatagramWriterGroupTransportParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UADatagramWriterGroupTransportParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UADatagramWriterGroupTransportParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAFieldMetaDataTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAFieldMetaDataTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAFieldMetaData));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAFieldMetaData...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAJsonDataSetWriterMessageParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAJsonDataSetWriterMessageParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAJsonDataSetWriterMessageParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAJsonDataSetWriterMessageParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAJsonWriterGroupMessageParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAJsonWriterGroupMessageParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAJsonWriterGroupMessageParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAJsonWriterGroupMessageParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPubSubComponentElementTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPubSubComponentElementTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPubSubComponentElement));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPubSubComponentElement...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPubSubConfigurationDataTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPubSubConfigurationDataTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPubSubConfigurationData));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPubSubConfigurationData...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPubSubConfigurationElementTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPubSubConfigurationElementTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPubSubConfigurationElement));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPubSubConfigurationElement...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPubSubConnectionDataTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPubSubConnectionDataTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPubSubConnectionData));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPubSubConnectionData...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPubSubConnectionElementTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPubSubConnectionElementTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPubSubConnectionElement));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPubSubConnectionElement...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPubSubGroupElementTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPubSubGroupElementTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPubSubGroupElement));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPubSubGroupElement...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPubSubObjectElementTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPubSubObjectElementTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPubSubObjectElement));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPubSubObjectElement...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPublishSubscribeElementTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPublishSubscribeElementTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPublishSubscribeElement));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPublishSubscribeElement...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPublishedDataItemsElementTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPublishedDataItemsElementTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPublishedDataItemsElement));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPublishedDataItemsElement...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPublishedDataSetDataTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPublishedDataSetDataTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPublishedDataSetData));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPublishedDataSetData...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPublishedDataSetElementTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPublishedDataSetElementTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPublishedDataSetElement));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPublishedDataSetElement...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPublishedDataSetSourceElementTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPublishedDataSetSourceElementTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPublishedDataSetSourceElement));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPublishedDataSetSourceElement...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPublishedEventsElementTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPublishedEventsElementTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPublishedEventsElement));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPublishedEventsElement...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPublishedVariableDataTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPublishedVariableDataTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPublishedVariableData));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAPublishedVariableData...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAReaderGroupElementTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAReaderGroupElementTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAReaderGroupElement));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAReaderGroupElement...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAReaderGroupMessageParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAReaderGroupMessageParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAReaderGroupMessageParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAReaderGroupMessageParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAReaderGroupTransportParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAReaderGroupTransportParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAReaderGroupTransportParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAReaderGroupTransportParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAUadpDataSetReaderMessageParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAUadpDataSetReaderMessageParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAUadpDataSetReaderMessageParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAUadpDataSetReaderMessageParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAUadpDataSetWriterMessageParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAUadpDataSetWriterMessageParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAUadpDataSetWriterMessageParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAUadpDataSetWriterMessageParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAUadpWriterGroupMessageParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAUadpWriterGroupMessageParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAUadpWriterGroupMessageParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAUadpWriterGroupMessageParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAWriterGroupDataTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAWriterGroupDataTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAWriterGroupData));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAWriterGroupData...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAWriterGroupElementTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAWriterGroupElementTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAWriterGroupElement));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAWriterGroupElement...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAWriterGroupMessageParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAWriterGroupMessageParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAWriterGroupMessageParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAWriterGroupMessageParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Configuration
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAWriterGroupTransportParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAWriterGroupTransportParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Configuration.UAWriterGroupTransportParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Configuration.UAWriterGroupTransportParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Diagnostics
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUASubscriberEventSourceTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUASubscriberEventSourceTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Diagnostics.EasyUASubscriberEventSource));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Diagnostics.EasyUASubscriberEventSource...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUASubscriberTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUASubscriberTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.EasyUASubscriber));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.EasyUASubscriber...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAPubSubResolverParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAPubSubResolverParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Engine.EasyUAPubSubResolverParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Engine.EasyUAPubSubResolverParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUASubscriberAdaptableParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUASubscriberAdaptableParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Engine.EasyUASubscriberAdaptableParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Engine.EasyUASubscriberAdaptableParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUASubscriberInstanceParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUASubscriberInstanceParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Engine.EasyUASubscriberInstanceParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Engine.EasyUASubscriberInstanceParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUASubscriberSharedParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUASubscriberSharedParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Engine.EasyUASubscriberSharedParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Engine.EasyUASubscriberSharedParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPubSubResolverParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPubSubResolverParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Engine.UAPubSubResolverParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Engine.UAPubSubResolverParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPublisherConfigurationResolutionParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPublisherConfigurationResolutionParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Engine.UAPublisherConfigurationResolutionParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Engine.UAPublisherConfigurationResolutionParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Engine
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UASubscriberAdaptableParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UASubscriberAdaptableParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Engine.UASubscriberAdaptableParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Engine.UASubscriberAdaptableParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.Implementation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EnqueuingEasyUASubscriberTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EnqueuingEasyUASubscriberTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.Implementation.EnqueuingEasyUASubscriber));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.Implementation.EnqueuingEasyUASubscriber...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.InformationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAPublishSubscribeClientTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAPublishSubscribeClientTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.InformationModel.EasyUAPublishSubscribeClient));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.InformationModel.EasyUAPublishSubscribeClient...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.InformationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class SimulatedEasyUAPublishSubscribeClientTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public SimulatedEasyUAPublishSubscribeClientTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.InformationModel.SimulatedEasyUAPublishSubscribeClient));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.InformationModel.SimulatedEasyUAPublishSubscribeClient...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUADataSetFieldMessageEventArgsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUADataSetFieldMessageEventArgsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.OperationModel.EasyUADataSetFieldMessageEventArgs));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.OperationModel.EasyUADataSetFieldMessageEventArgs...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUADataSetMessageEventArgsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUADataSetMessageEventArgsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.OperationModel.EasyUADataSetMessageEventArgs));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.OperationModel.EasyUADataSetMessageEventArgs...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUADataSetSubscriptionChangeArgumentsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUADataSetSubscriptionChangeArgumentsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.OperationModel.EasyUADataSetSubscriptionChangeArguments));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.OperationModel.EasyUADataSetSubscriptionChangeArguments...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUAResolverAccessEventArgsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUAResolverAccessEventArgsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.OperationModel.EasyUAResolverAccessEventArgs));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.OperationModel.EasyUAResolverAccessEventArgs...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUASubscribeDataSetArgumentsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUASubscribeDataSetArgumentsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.OperationModel.EasyUASubscribeDataSetArguments));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.OperationModel.EasyUASubscribeDataSetArguments...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUASubscribeDataSetArgumentsDictionaryTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUASubscribeDataSetArgumentsDictionaryTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.OperationModel.EasyUASubscribeDataSetArgumentsDictionary));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.OperationModel.EasyUASubscribeDataSetArgumentsDictionary...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EasyUASubscribeDataSetFieldArgumentsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EasyUASubscribeDataSetFieldArgumentsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.OperationModel.EasyUASubscribeDataSetFieldArguments));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.OperationModel.EasyUASubscribeDataSetFieldArguments...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub.OperationModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UASubscribeDataSetArgumentsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UASubscribeDataSetArgumentsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.OperationModel.UASubscribeDataSetArguments));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.OperationModel.UASubscribeDataSetArguments...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataSetDataTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataSetDataTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.UADataSetData));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.UADataSetData...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataSetFieldDataTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataSetFieldDataTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.UADataSetFieldData));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.UADataSetFieldData...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataSetSubscriptionDescriptorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataSetSubscriptionDescriptorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.UADataSetSubscriptionDescriptor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.UADataSetSubscriptionDescriptor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataSetWriterDescriptorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataSetWriterDescriptorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.UADataSetWriterDescriptor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.UADataSetWriterDescriptor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPubSubCommunicationParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPubSubCommunicationParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.UAPubSubCommunicationParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.UAPubSubCommunicationParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPubSubConnectionDescriptorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPubSubConnectionDescriptorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.UAPubSubConnectionDescriptor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.UAPubSubConnectionDescriptor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPubSubResolverDescriptorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPubSubResolverDescriptorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.UAPubSubResolverDescriptor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.UAPubSubResolverDescriptor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPublisherIdTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPublisherIdTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.UAPublisherId));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.UAPublisherId...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UASubscribeDataSetFilterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UASubscribeDataSetFilterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.UASubscribeDataSetFilter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.UASubscribeDataSetFilter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UASubscriberCommunicationParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UASubscriberCommunicationParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.UASubscriberCommunicationParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.UASubscriberCommunicationParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.PubSub
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAWriterGroupDescriptorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAWriterGroupDescriptorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.PubSub.UAWriterGroupDescriptor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.PubSub.UAWriterGroupDescriptor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Reactive
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAReactiveTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAReactiveTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Reactive.UAReactive));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Reactive.UAReactive...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Toolkit.ClientServer
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAClientEngineTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAClientEngineTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Toolkit.ClientServer.UAClientEngine));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Toolkit.ClientServer.UAClientEngine...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Toolkit.ClientServer
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAClientEngineBaseTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAClientEngineBaseTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Toolkit.ClientServer.UAClientEngineBase));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Toolkit.ClientServer.UAClientEngineBase...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Toolkit.ClientServer
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAClientServerEngineTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAClientServerEngineTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Toolkit.ClientServer.UAClientServerEngine));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Toolkit.ClientServer.UAClientServerEngine...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Toolkit.ClientServer
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAClientServerEngineBaseTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAClientServerEngineBaseTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Toolkit.ClientServer.UAClientServerEngineBase));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Toolkit.ClientServer.UAClientServerEngineBase...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Toolkit.ClientServer
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UASmartClientEngineTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UASmartClientEngineTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Toolkit.ClientServer.UASmartClientEngine));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Toolkit.ClientServer.UASmartClientEngine...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Toolkit.ClientServer
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAWriteOutcomeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAWriteOutcomeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Toolkit.ClientServer.UAWriteOutcome));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Toolkit.ClientServer.UAWriteOutcome...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Toolkit.Diagnostics
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAEngineEventSourceTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAEngineEventSourceTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Toolkit.Diagnostics.UAEngineEventSource));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Toolkit.Diagnostics.UAEngineEventSource...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Toolkit.PubSub.Sdk
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class TransportConditionChangedEventArgsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public TransportConditionChangedEventArgsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Toolkit.PubSub.Sdk.TransportConditionChangedEventArgs));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Toolkit.PubSub.Sdk.TransportConditionChangedEventArgs...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Toolkit.PubSub
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPubSubEngineTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPubSubEngineTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Toolkit.PubSub.UAPubSubEngine));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Toolkit.PubSub.UAPubSubEngine...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Toolkit.PubSub
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAPubSubSmartEngineTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAPubSubSmartEngineTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Toolkit.PubSub.UAPubSubSmartEngine));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Toolkit.PubSub.UAPubSubSmartEngine...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Toolkit
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAEngineTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAEngineTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Toolkit.UAEngine));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Toolkit.UAEngine...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA.Toolkit
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAEngineBaseTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAEngineBaseTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.Toolkit.UAEngineBase));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.Toolkit.UAEngineBase...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAAttributeDataTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAAttributeDataTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAAttributeData));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAAttributeData...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAAttributeFieldTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAAttributeFieldTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAAttributeField));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAAttributeField...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAAttributeFieldCollectionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAAttributeFieldCollectionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAAttributeFieldCollection));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAAttributeFieldCollection...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UABrowseParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UABrowseParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UABrowseParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UABrowseParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UACallServiceExceptionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UACallServiceExceptionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UACallServiceException));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UACallServiceException...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataChangeFilterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataChangeFilterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UADataChangeFilter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UADataChangeFilter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataTypeSchemaTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataTypeSchemaTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UADataTypeSchema));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UADataTypeSchema...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UADataValueTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UADataValueTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UADataValue));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UADataValue...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAEndpointDescriptorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAEndpointDescriptorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAEndpointDescriptor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAEndpointDescriptor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAEndpointDescriptorCollectionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAEndpointDescriptorCollectionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAEndpointDescriptorCollection));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAEndpointDescriptorCollection...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAEndpointDescriptorUANodeIdDictionaryTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAEndpointDescriptorUANodeIdDictionaryTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAEndpointDescriptorUANodeIdDictionary));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAEndpointDescriptorUANodeIdDictionary...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAEventDataTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAEventDataTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAEventData));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAEventData...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAEventFilterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAEventFilterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAEventFilter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAEventFilter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAEventFilterBuilderTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAEventFilterBuilderTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAEventFilterBuilder));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAEventFilterBuilder...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAExtensionObjectTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAExtensionObjectTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAExtensionObject));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAExtensionObject...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAFieldResultDictionaryTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAFieldResultDictionaryTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAFieldResultDictionary));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAFieldResultDictionary...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAIndexRangeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAIndexRangeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAIndexRange));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAIndexRange...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAIndexRangeListTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAIndexRangeListTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAIndexRangeList));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAIndexRangeList...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAKeyValueDictionaryTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAKeyValueDictionaryTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAKeyValueDictionary));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAKeyValueDictionary...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAKeyValuePairTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAKeyValuePairTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAKeyValuePair));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAKeyValuePair...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UALocalizedTextTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UALocalizedTextTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UALocalizedText));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UALocalizedText...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAMonitoringParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAMonitoringParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAMonitoringParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAMonitoringParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANodeDescriptorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANodeDescriptorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UANodeDescriptor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UANodeDescriptor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UANodeIdUAApplicationElementDictionaryTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UANodeIdUAApplicationElementDictionaryTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UANodeIdUAApplicationElementDictionary));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UANodeIdUAApplicationElementDictionary...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAReadParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAReadParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAReadParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAReadParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAResultExceptionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAResultExceptionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAResultException));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAResultException...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAServiceExceptionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAServiceExceptionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAServiceException));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAServiceException...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAServiceResultTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAServiceResultTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAServiceResult));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAServiceResult...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAStatusCodeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAStatusCodeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAStatusCode));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAStatusCode...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UAStatusCodeExceptionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UAStatusCodeExceptionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UAStatusCodeException));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UAStatusCodeException...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UASubscriptionParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UASubscriptionParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UASubscriptionParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UASubscriptionParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.EasyOpcTest.UA
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UATimeZoneDataTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UATimeZoneDataTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.EasyOpc.UA.UATimeZoneData));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.EasyOpc.UA.UATimeZoneData...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("OpcUA")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}
